import { bytesToSize, getUrl, getUrl2 } from 'educoder'
const $ = window.$

export function isImageExtension(fileName) {
    return fileName ? !!(fileName.match(/.(jpg|jpeg|png|gif)$/i)) : false
}

function _doDownload(options) {
    $.fileDownload(getUrl() + "/api" + options.url, {
        successCallback: options.successCallback,
        failCallback: options.failCallback
    });
}
export function downloadFile(options) {
    if ($.fileDownload) {
        _doDownload(options)
    } else {
        const _url_origin = getUrl2()
        $.getScript(
            `${_url_origin}/javascripts/download/jquery.fileDownload.min.js`,
            (data, textStatus, jqxhr) => {
                _doDownload(options)
            });
    }

}

export function appendFileSizeToUploadFile(item) {
    return `${item.title}${uploadNameSizeSeperator}${item.filesize}`
}
export function appendFileSizeToUploadFileAll(fileList) {
    return fileList.map(item => {
        if (item.name.indexOf(uploadNameSizeSeperator) == -1) {
            return Object.assign({}, item, { name: `${item.name}${uploadNameSizeSeperator}${bytesToSize(item.size)}` })
        }
        return item
    })
}
export const uploadNameSizeSeperator = '　　'

export const sortDirections = ["ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend",
    "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend",
    "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend",
    "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend", "ascend", "descend",]

export function validateLength(str = '', length = 100) {
    let len = 0
    if (str) {
        len = str.length
        for (let i = 0; i < len; i++) {
            let charCode = str.charCodeAt(i)
            if (charCode >= 0xD800 && charCode <= 0xDBFF) {
                len--
                i++
            }
        }
    }
    return len <= length
}

export function getCourseParam() {
    let courseId
    let query = window.location.pathname
    const type = query.split('/')
    if (type[1] == 'classrooms' && type[2]) {
        courseId = parseInt(type[2])
    }
    return { course_id: isNaN(courseId) ? undefined : courseId, school: 1 }
}