import React from "react";
import md5 from 'md5';
import {Input} from "antd";
import { baseRequestUrl } from 'educoder';
const { Search } = Input;

const $ = window.$;
const isDev = window.location.port === "3007";
const isEducoderHost= window.location.hostname ==='www.educoder.net';
const cdnUrl = 'https://ali-cdn.educoder.net';

export const TEST_HOST = "https://test-newweb.educoder.net";
export function getImageUrl(path) {
	if (isDev) {
		return `${baseRequestUrl}/${path}`
	}
	return `/${path}`;
}

export function getcdnImageUrl(path) {
	let firstStr = path.substr(0,1);
	if (isEducoderHost) {
		return `${cdnUrl}/${path}`;
	}else{
    return firstStr === "/" ? `${path}` : `/${path}`;
	}
}

export function setImagesUrl(path) {
  let firstStr = path.substr(0,1);
  if (isEducoderHost) {
    return `${cdnUrl}${path}`;
  } else {
    return firstStr === "/" ? `${path}` : `/${path}`;
  }
}


export function getUrl(path, goTest) {
	if (isDev) {
		return `${baseRequestUrl}${path?path:''}`
	}
	return `${path ? path: ''}`;
}

export function getUrlmys(path, goTest) {
	if (isDev) {
		return `${baseRequestUrl}${path?path:''}`
	}
	return `${path ? path: ''}`;
}
export function getStaticUrl() {
	if (isDev) {
		return baseRequestUrl
	}
	// todo cdn
	return ''
}
export function getUrl2(path, goTest) {
	if (isDev) {
		return `${baseRequestUrl}${path?path:''}`
	}
	return `${path ? path: ''}`;
}
const newopens ="79e33abd4b6588941ab7622aed1e67e8";
let newtimestamp;
let checkSubmitFlgs = false;
function railsgettimess(proxy) {
 if(checkSubmitFlgs===false){
		$.ajax({url:proxy,
			async:false,success:function(data){
				if(data.status===0){
					newtimestamp=data.message;
					checkSubmitFlgs = true;
				}
			}})

		window.setTimeout(function () {
			checkSubmitFlgs=false;
		}, 2500);
	}
}


export function Railsgettimes() {
	railsgettimess(`${getUrl()}/api/main/first_stamp.json`);
	// railsgettimess(`https://api.m.taobao.com/rest/api3.do?api=mtop.common.getTimestamp`);
}
export function getmyUrl(geturl) {
	return `${getUrl()}${geturl}`;
}

export function getUploadActionUrl(path, goTest) {
	let anewopens=md5(newopens+newtimestamp);
	return `${getUrl()}/api/attachments.json${isDev ? `?debug=${window._debugType || 'admin'}&randomcode=${newtimestamp}&client_key=${anewopens}` : `?randomcode=${newtimestamp}&client_key=${anewopens}`}`;
}

export function getUploadLogoActionUrl() {
	let anewopens=md5(newopens+newtimestamp);
	return `${getUrl()}/api/resumes/logo.json${isDev ? `?debug=${window._debugType || 'admin'}&randomcode=${newtimestamp}&client_key=${anewopens}` : `?randomcode=${newtimestamp}&client_key=${anewopens}`}`;
}

export function getUploadActionUrltwo(id) {
	let anewopens=md5(newopens+newtimestamp);
	return `${getUrlmys()}/api/shixuns/${id}/upload_data_sets.json${isDev ? `?debug=${window._debugType || 'admin'}&randomcode=${newtimestamp}&client_key=${anewopens}` : `?randomcode=${newtimestamp}&client_key=${anewopens}`}`
}

export function getUploadActionUrlthree() {
	let anewopens=md5(newopens+newtimestamp);
	return `${getUrlmys()}/api/jupyters/import_with_tpm.json${isDev ? `?debug=${window._debugType || 'admin'}&randomcode=${newtimestamp}&client_key=${anewopens}` : `?randomcode=${newtimestamp}&client_key=${anewopens}`}`
}

export function getupload_git_file(id) {
	let anewopens=md5(newopens+newtimestamp);
	return `${getUrlmys()}/api/shixuns/${id}/upload_git_file.json${isDev ? `?debug=${window._debugType || 'admin'}&randomcode=${newtimestamp}&client_key=${anewopens}` : `?randomcode=${newtimestamp}&client_key=${anewopens}`}`
}


export function getUploadActionUrlOfAuth(id) {
	let anewopens=md5(newopens+newtimestamp);
	return `${getUrl()}/api/users/accounts/${id}/auth_attachment.json${isDev ? `?debug=${window._debugType || 'admin'}&randomcode=${newtimestamp}&client_key=${anewopens}` : `?randomcode=${newtimestamp}&client_key=${anewopens}`}`
}

export function getRandomNumber(type) {
	let anewopens=md5(newopens+newtimestamp);
	return type===true?`randomcode=${newtimestamp}&client_key=${anewopens}`:`?randomcode=${newtimestamp}&client_key=${anewopens}`
}

export function test(path) {
	return `${path}`;
}

export function toPath(path) {
	window.open(path, '_blank');
}


export function getTaskUrlById(id) {
	return `/tasks/${id}`
}

export function getRandomcode(url) {
	let anewopens=md5(newopens+newtimestamp);

	if (url.indexOf('?') == -1) {
		return `${url}?randomcode=${newtimestamp}&client_key=${anewopens}`
	}else {
		return `${url}&randomcode=${newtimestamp}&client_key=${anewopens}`
	}

}

export function htmlEncode(str) {
	var s = "";
	if (str.length === 0) {
		return "";
	}
	s = str.replace(/&/g, "&amp;");
	s = s.replace(/</g, "&lt;");
	s = s.replace(/>/g, "&gt;");
	s = s.replace(/ /g, "&nbsp;");
	s = s.replace(/\'/g, "&#39;");//IE下不支持实体名称
	s = s.replace(/\"/g, "&quot;");
	return s;
}

export function publicSearchs(Placeholder,onSearch,onInputs,onChanges,loadings) {
	return(<Search
		placeholder= { Placeholder || "请输入内容进行搜索" }
		onSearch={onSearch}
		// value={searchValue}
		onInput={onInputs}
		onChange={onChanges}
		loading={loadings||false}
		allowClear={true}
	></Search>)
}
