/*
 * @Description: 评论表单
 * @Author: tangjiang
 * @Github:
 * @Date: 2019-12-17 17:32:55
 * @LastEditors  : tangjiang
 * @LastEditTime : 2020-01-06 18:42:09
 */
import './index.scss';
import React, { useState } from 'react';
import { Form, Button, Input } from 'antd';
import TpmMdEditor from '../../../modules/tpm/challengesnew/tpm-md-editor';
const FormItem = Form.Item;

function CommentForm(props) {

  const {
    mdID,
    onCancel,
    onSubmit,
    form,
    type
  } = props;

  const { getFieldDecorator } = form;
  const [ctx, setCtx] = useState('');

  const [showQuill, setShowQuill] = useState(false);
  // 点击输入框
  const handleInputClick = (type) => {
    setShowQuill(true);
  }
  // 取消
  const handleCancle = () => {
    setShowQuill(false);
    setCtx('');
    props.form.resetFields();
    onCancel && onCancel();
  }

  // 编辑器内容变化时
  const handleContentChange = (value) => {
    setCtx(value)
    props.form.setFieldsValue({ 'comment': value });
  }
  // 发送
  const handleSubmit = (e) => {
    e.preventDefault();
    props.form.validateFields((err, values) => {
      if (!err) {
        setShowQuill(false);
        props.form.setFieldsValue({ 'comment': '' });
        setCtx('');
        onSubmit && onSubmit(ctx);
      }
    });
  }

  // const _clazz = type === 'bottom' ? 'comment_form_bottom_area' : 'comment_form_area';
  let _clazz;
  if (type === 'bottom') {
    _clazz = showQuill ? 'comment_form_bottom_area active' : 'comment_form_bottom_area';
  } else {
    _clazz = 'comment_form_area';
  }
  return (
    <Form className={_clazz}>
      <FormItem>
        {
          getFieldDecorator('comment', {
            rules: [
              { required: true, message: '评论内容不能为空' }
            ],
          })(
            <Input
              onClick={() => handleInputClick(type)}
              placeholder="说点儿什么~"
              className={showQuill ? '' : 'show_input'}
              style={{
                height: showQuill ? '0px' : '40px',
                overflow: showQuill ? 'hidden' : 'auto',
                opacity: showQuill ? 0 : 1,
              }}
            />
          )
        }
        <div className='comment-item-editor' style={{ display: showQuill ? 'block' : 'none', width: '100%' }}>
          <TpmMdEditor
            className='mini'
            startInit={showQuill}
            mdID={mdID}
            height={150}
            placeholder="说点儿什么~"
            watch={false}
            initValue={ctx}
            onChange={handleContentChange}
          />
        </div>

      </FormItem>
      <FormItem style={{ textAlign: 'right', display: showQuill ? 'block' : 'none' }}>
        <Button onClick={handleCancle}>取消</Button>
        <Button onClick={handleSubmit} type="primary" style={{ marginLeft: '10px' }}>发送</Button>
      </FormItem>
    </Form>
  );
}

export default Form.create()(CommentForm);
