import React,{ Component } from "react";
import { Modal , Form , Input , Spin , Select , AutoComplete , DatePicker , InputNumber } from 'antd';
import axios from 'axios';

class VideoLink extends Component{

  componentDidUpdate=(prevProps)=>{
    if(prevProps.visible !== this.props.visible){
      this.props.form.setFieldsValue({
        name:undefined,
        link:undefined
      })
    }
  }
  cancelNew=()=>{
    const { setVisible } = this.props;
    setVisible && setVisible(false);
  }
  validateDesc= (rule, value, callback) => {
    if(!value){
      callback();
    }
    if (value.length > 60) {
      callback("视频名称不能超过60个字！");
    }else{
      callback();
    }
  }
  // 提交
  handleSubmit=()=>{
    this.props.form.validateFields((err, values) => {
      if(!err){
        const { coursesId , videoId } = this.props;
        const url = `/courses/${coursesId}/course_videos.json`;
        axios.post(url,{
          ...values,
          category_id:videoId
        }).then(result=>{
          if(result){
            const { notification , setVisible } = this.props;
            notification && notification('视频外链新增成功！');
            setVisible && setVisible(false,true);
          }
        }).catch(error=>{
          console.log(error);
        })
      }
    })
  }
  render(){
    const {getFieldDecorator} = this.props.form;

    const { visible } = this.props;
    const layout = {
      labelCol: { span: 5 },
      wrapperCol: { span: 19 },
    }
    return(
      <Modal
        visible={visible}
        width="560px"
        title={'添加外链'}
        footer={null}
        closable={false}
        centered={true}
      >
        <div className="task-popup-content">
          <Form onSubmit={this.handleSubmit} {...layout}>
            <Form.Item label={`视频名称：`}>
              {getFieldDecorator('name', {
                    rules: [{required: true, message: "请输入名称"},{
                      validator: this.validateDesc,
                    }],
                })(
                  <Input placeholder="请输入名称，最大限制60个字符" />
                )}
            </Form.Item>
            <Form.Item label={`链接地址：`}>
              {getFieldDecorator('link', {
                    rules: [{required: true, message: "请输入链接地址"}],
                })(
                  <Input placeholder="请输入链接地址" />
                )}
            </Form.Item>
            <div className="clearfix mt30 edu-txt-center">
              <a onClick={this.cancelNew} className="task-btn mr30">取消</a>
              <a type="submit" onClick={this.handleSubmit} className="task-btn task-btn-orange">确定</a>
            </div>
          </Form>
        </div>
      </Modal>
    )
  }
}
const WrappedVideoLink = Form.create({name: 'VideoLink'})(VideoLink);
export default WrappedVideoLink;