import React, { Component } from "react";
import { on, off } from 'educoder';
import axios from 'axios';
import NoneData from '../coursesPublic/NoneData'
import '../css/Courses.css'
import RenderHtml from "../../../components/render-html";

class CommonWorkAnswer extends Component {

  constructor(props) {
    super(props)
    this.state = {
      course_name: "",
      homework_name: "",
      search: ''
    }
  }
  fetchData = () => {
    let workId = this.props.match.params.workId;
    const url = `/homework_commons/${workId}/reference_answer.json`

    axios.get(url).then((result) => {
      if (result.data.course_id) {

        this.setState({
          ...result.data
        }, () => {
        })
        this.props.initWorkDetailCommonState && this.props.initWorkDetailCommonState(Object.assign({ ...result.data }, {
          moduleName: '参考答案'
        }))
      }

    }).catch((error) => {
      console.log(error)
    })
  }
  componentDidMount() {
    this.fetchData()
    try {
      this.props.triggerRef(this);
    } catch (e) {

    }
    on('commonwork_fetch_all', this.fetchAllListener)
  }
  componentWillUnmount() {
    off('commonwork_fetch_all', this.fetchAllListener)
  }
  fetchAllListener = () => {
    this.fetchData()
  }


  render() {

    let { reference_answer, attachments } = this.state;

    return (
      <React.Fragment
      >
        {/* 内容区 */}
        <div className="padding40 memoContent new_li">
          {reference_answer ? <RenderHtml value={reference_answer || "还未设置答案。"} /> :
            reference_answer === undefined ? '' : ((!attachments || attachments.length == 0) && <NoneData></NoneData>)}

          {attachments && attachments.map((item) => {
            return (<div className="color-grey">
              <a className="color-grey">
                <i className="font-14 color-green iconfont icon-fujian mr8" aria-hidden="true"></i>
              </a>
              <a href={item.url} className="mr12" length="58">{item.title}</a>
              <span className="color-grey mt2 color-grey-6 font-12">{item.filesize}</span>
            </div>)
          })}

        </div>

      </React.Fragment>

    )
  }
}

export default CommonWorkAnswer;
