import React,{ Component } from "react";
import { Select, AutoComplete } from "antd";
import { WordsBtn, getUrl, getUploadActionUrl} from 'educoder';
import axios from 'axios';

const Option = Select.Option;

let timeout, currentValue

class SchoolSelect extends Component{
    constructor(props){
        super(props);
        this.state={
            school_names: '',
            //新增参数 防止重复请求 
            school_list:[]
        }
    }


    componentDidMount() {
        this.getschool();
    }
    getschool=(value)=>{
        const url = `/schools/school_list.json`
        axios.get(url,{
        search: value  
        }).then((response)=>{
            this.setState({school_list:response.data.school_names}) 
        })
    }
  
    onselect=(value,type)=>{
        this.props.onSelect(value)
    }

    onOrgNameSearch = (value) => {
       const {school_list}=this.state;
   
       this.setState({
           school_names:school_list.filter(item=>item.indexOf(value)>=0)
        })    
    }
    render () {
        const { school_names } = this.state;
        const { value, onChange,isTeacher,onSelect} = this.props;
        return (
            <AutoComplete allowClear placeholder="请输入单位名称" value={value} 
                style={{ width: isTeacher?'410px':'221px'}} 
                onSearch={this.onOrgNameSearch}
                onSelect={this.onselect}
                onChange={onChange}
                dataSource={school_names}
                defaultOpen={false}
            >
                { school_names && school_names.map((item, index) => {
                    return <Option value={item} key={index}>{item}</Option>
                })}
            </AutoComplete>
        )
    }
}
export default SchoolSelect;