import React, { Component } from "react";
import { Spin, Popover } from "antd";
import { queryString, getRandomcode } from "educoder";
import "../../css/members.css";
import "../../css/busyWork.css";
import axios from "axios";
import Modals from "../../../modals/Modals";
import DownloadMessageysl from "../../../modals/DownloadMessageysl";
import Studentshavecompletedthelist from "./../Studentshavecompletedthelist";
import WrappedExercisesetting from "./../Exercisesetting";
import ExerciseDisplay from "./../ExerciseDisplay";
import Exercisestatisticalresult from "./../RandomSstatistics";
import ImmediatelyPublish from "../../poll/pollPublicBtn/IMP";
import ImmediatelyEnd from "../../poll/pollPublicBtn/IME";
import Ecerciseallbackagain from "./../Ecerciseallbackagain";

import { Link } from "react-router-dom";
import Menu from "./../util/widget/Menu";
import { Background, BetweenBox, FlexBox, Paper } from "./../util/layout";
import { IconBtn } from "./../util/widget/button";
import { Title } from "./../util/widget/typography";
//import Popover from "./util/widget/Popover";
import StatusTag from "./../util/widget/StatusTag";
import Nav from "./../util/widget/Nav";
import { OutlineBtn } from "./../util/widget/button";
import { List, LstItem } from "./../util/widget/lst";
import styled from "styled-components";
import { HooksMocker } from "./../util/hooks";
import AnsLst from "./../new-detail/AnswerLst";
import { Icon } from "./../util/widget";

const BtnGrp = styled.div`
  display: flex;
  & > div:not(:last-child) {
    margin-right: 8px;
  }
`;
const Box = styled(BetweenBox)`
  padding: 0 24px;
  height: 64px;
  border-bottom: 1px solid rgba(0, 0, 0, 0.06);
`;

const polls_status = { 1: "未发布", 2: "考试中", 3: "已截止", 4: "已结束" };
const start_Value = { 0: "继续答题", 1: "查看答题", 2: "开始答题" };
const qs = require("qs");
//试卷主要设置页面
class Testpapersettinghomepage extends Component {
  constructor(props) {
    super(props);
    this.state = {
      tab: 0,
      searchtext: "",
      Commonheadofthetestpaper: undefined,
      visible: false,
      groupyslsval: "",
      current_status: undefined,
      DownloadType: false,
      DownloadMessageval: undefined,
      donwloading: false,
      exercise_status: 3,
      assistant_auth: false, //设置助教
    };
  }
  //切换tab
  changeTab = (e, s) => {
    if (typeof s == "number") {
      this.setState({
        tab: s,
      });
    } else {
      this.setState({
        tab: e.key,
      });
    }
  };
  componentDidMount() {
    const query = this.props.location.search;
    const type = query.split("?tab=");
    this.setState({
      tab: parseInt(type[1]),
    });
    this.Commonheadofthetestpaper();
  }
  //试卷公用头部
  Commonheadofthetestpaper = () => {
    var exercise_id = this.props.match.params.Id;
    var url = `/exercises/${exercise_id}/common_header.json`;
    axios
        .get(url)
        .then((response) => {
          try {
            if (response.status === 200) {
              this.setState({
                Commonheadofthetestpaper: response.data,
                current_status: response.data.user_permission.current_status,
                exercise_status: response.data.exercise_status,
                assistant_auth: response.data.assistant_auth,
              });
            }
          } catch (e) {}
        })
        .catch((error) => {
          console.log(error);
        });
  };

  assistantauthoritys = (bool) => {
    this.setState({
      assistant_auth: bool,
    });
  };

  Ecerciseacallagain = () => {
    this.setState({
      visible: true,
    });
  };
  callback = (val) => {
    this.setState({
      visible: false,
    });
    if (val === 1) {
      window.location.reload();
    }
  };

  moveTos = (val) => {
    if (val === 0) {
    }
  };

  setcourse_groupysls = (val) => {
    let list = "";
    val.map((item, key) => {
      if (item !== undefined) {
        list = list + "&exercise_group_id[]=" + item;
      }
    });
    this.setState({
      groupyslsval: list,
    });
  };
  setgameexercise = (url) => {
    let { Commonheadofthetestpaper } = this.state;
    if (Commonheadofthetestpaper.time > 0) {
      this.setState({
        Modalstype: true,
        ModalSave: () => this.props.history.push(url),
        Modalstopval: `答题时长限制${Commonheadofthetestpaper.time}分钟，从首次答题开始实行不间断计时`,
        modalsBottomval: "请确认是否有充足的答题时间？",
      });
    } else {
      this.setState({
        Modalstype: true,
        ModalSave: () => this.props.history.push(url),
        Modalstopval: "是否确认开始答题？",
        modalsBottomval: " ",
      });
    }
  };
  //打开pdf
  confpdf = (url) => {
    window.open(url);
  };
  /// 确认是否下载
  confirmysl(url, child) {
    let params = {};
    if (child != undefined) {
      params =
          child._getRequestParams() !== undefined
              ? child._getRequestParams()
              : {};
    }

    const urll = url + `?${queryString.stringify(params)}`;

    axios
        .get(urll + "&export=true")
        .then((response) => {
          if (response === undefined) {
            return;
          }
          if (response.data.status && response.data.status === -1) {
          } else if (response.data.status && response.data.status === -2) {
            if (response.data.message === "100") {
              // 已超出文件导出的上限数量（100 ），建议：

              this.setState({
                DownloadType: true,
                DownloadMessageval: 100,
              });
            } else {
              //因附件资料超过500M
              this.setState({
                DownloadType: true,
                DownloadMessageval: 500,
              });
            }
          } else {
            this.props.slowDownload(getRandomcode(urll));
          }
        })
        .catch((error) => {
          console.log(error);
        });
  }

  Downloadcal = () => {
    this.setState({
      DownloadType: false,
      DownloadMessageval: undefined,
    });
  };
  cancelmodel = () => {
    this.setState({
      Modalstype: false,
      ModalSave: " ",
      Modalstopval: " ",
      modalsBottomval: " ",
      Loadtype: false,
    });
  };
  getsetdata = () => {
    let { tab } = this.state;
    try {
      if (tab === "0") {
        this.child.Teacherliststudentlist();
      }
      if (tab === "1") {
        this.child.Teacherliststudentlist();
      }
      // if (tab === "2") {
      //   this.child.Teacherliststudentlist();
      // }
      if (tab === "3") {
        this.child.getSettingInfo();
      }
    } catch (e) {}
  };
  bindRef = (ref) => {
    this.child = ref;
  };
  goback = () => {
    // }
    this.props.history.goBack();
  };
  render() {
    let {
      tab,
      visible,
      Commonheadofthetestpaper,
      exercise_status,
      assistant_auth,
    } = this.state;
    const isAdmin = this.props.isAdmin();
    const isAssistant = this.props.isAssistant();
    const isStudent = this.props.isStudent();
    // TODO
    const [coursesId, exerciseId] = [
      this.props.match.params.coursesId,
      this.props.match.params.Id,
    ];
    const map1 = { 答题列表: 0, 统计结果: 1,  设置: 2 };
    const map2 = ["答题列表", "统计结果","设置"];
    const calc = () => {
      if ((isAssistant && assistant_auth) || isAdmin) {
        return ["答题列表", "统计结果", "设置"];
      }
      if (
          Commonheadofthetestpaper &&
          Commonheadofthetestpaper.show_statistic &&
          Commonheadofthetestpaper.exercise_status === 3
      ) {
        return ["答题列表", "统计结果", "设置"];
      }
      return ["答题列表", "设置"];
    };
    const menuArr = calc();
    document.title = this.props.coursedata && this.props.coursedata.name;
    return (
        <Background>
          {/* 公用的提示弹框 */}
          {this.state.Modalstype === true ? (
              <Modals
                  modalsType={this.state.Modalstype}
                  modalsTopval={this.state.Modalstopval}
                  modalsBottomval={this.state.modalsBottomval}
                  loadtype={this.state.Loadtype}
                  modalCancel={this.cancelmodel}
                  modalSave={this.state.ModalSave}
                  antIcon={this.state.Modalstypeloding}
              ></Modals>
          ) : null}
          {visible === true ? (
              <Ecerciseallbackagain
                  {...this.props}
                  modalname={"打回重做"}
                  visible={visible}
                  callback={this.callback}
              />
          ) : null}
          <Nav
              items={[
                <Link to={`/classrooms/${coursesId}`}>
                  {this.props.coursedata.name}
                </Link>,
                <Link
                    to={`/classrooms/${coursesId}/exercises/${
                        Commonheadofthetestpaper &&
                        Commonheadofthetestpaper.user_permission.left_banner_id
                    }`}
                >
                  试卷
                </Link>,
                "试卷详情",
              ]}
          />
          <FlexBox style={{ margin: "15px 0", alignItems: "center" }}>
            <IconBtn
                style={{ margin: "0 5px" }}
                type="arrow-left"
                onClick={() =>
                    this.props.history.push(
                        `/classrooms/${coursesId}/exercises/${
                            Commonheadofthetestpaper &&
                            Commonheadofthetestpaper.user_permission.left_banner_id
                        }`
                    )
                }
            />
            <Title style={{ margin: "0 5px" }}>
              {Commonheadofthetestpaper && Commonheadofthetestpaper.exercise_name}
            </Title>
            <span style={{
              width:52,
              height:20,
              lineHeight:"20px",
              textAlign:"center",
              background:"#84B6EB",
              color:"#FFF",
              borderRadius:20,
              fontSize:12,
              marginRight:4
            }}>随机</span>
            <StatusTag
                type={`${
                    polls_status[
                    Commonheadofthetestpaper &&
                    Commonheadofthetestpaper.exercise_status
                        ]
                }`}
            />
          </FlexBox>

          <Paper>
            <Box>
              <Menu
                  itemArr={menuArr}
                  onChange={(v) => {
                    this.changeTab(undefined, map1[v]);
                  }}
                  value={map2[tab]}
              />
              <BtnGrp>
                {isAdmin === true &&
                Commonheadofthetestpaper &&
                Commonheadofthetestpaper.user_permission.user_commit_counts > 0 &&
                Commonheadofthetestpaper.exercise_status === 2 ? (
                    <OutlineBtn onClick={this.Ecerciseacallagain}>
                      <Icon>&#xe762;</Icon>&nbsp;打回重做
                    </OutlineBtn>
                ) : null}

                {isAdmin === true ? (
                    Commonheadofthetestpaper !== undefined &&
                    Commonheadofthetestpaper.user_permission
                        .exercise_publish_count > 0 ? (
                        <ImmediatelyEnd
                            {...this.props}
                            {...this.state}
                            checkBoxValues={[parseInt(this.props.match.params.Id)]}
                            Exercisetype={"exercise"}
                            action={this.Commonheadofthetestpaper}
                        ></ImmediatelyEnd>
                    ) : null
                ) : null}
                {isAdmin === true ? (
                    Commonheadofthetestpaper !== undefined &&
                    Commonheadofthetestpaper.user_permission
                        .exercise_unpublish_count > 0 ? (
                        <ImmediatelyPublish
                            {...this.props}
                            {...this.state}
                            checkBoxValues={[parseInt(this.props.match.params.Id)]}
                            Exercisetype={"exercise"}
                            pushtype={true}
                            action={this.Commonheadofthetestpaper}
                            single={true}
                            getsetdata={this.getsetdata}
                        ></ImmediatelyPublish>
                    ) : null
                ) : null}

                {isAdmin === true ? (
                    isAssistant === true ? (
                        assistant_auth === true ? (
                            <OutlineBtn
                                onClick={() => {
                                  this.props.history.push(
                                      `/classrooms/${this.props.match.params.coursesId}/exercises/${this.props.match.params.Id}/randomEdit`
                                  );
                                }}
                            >
                              <Icon>&#xe761;</Icon>&nbsp;编辑试卷
                            </OutlineBtn>
                        ) : null
                    ) : (
                        <OutlineBtn
                            onClick={() => {
                              this.props.history.push(
                                  `/classrooms/${this.props.match.params.coursesId}/exercises/${this.props.match.params.Id}/randomEdit`
                              );
                            }}
                        >
                          <Icon>&#xe761;</Icon>&nbsp;编辑试卷
                        </OutlineBtn>
                    )
                ) : null}

                {isAdmin === false && this.props.current_user !== undefined ? (
                    Commonheadofthetestpaper &&
                    Commonheadofthetestpaper.user_permission.current_status ===
                    2 ? (
                        <OutlineBtn
                            onClick={() =>
                                this.setgameexercise(
                                    `/classrooms/${this.props.match.params.coursesId}/exercises/${this.props.match.params.Id}/users/${this.props.current_user.login}`
                                )
                            }
                        >
                          开始答题
                        </OutlineBtn>
                    ) : (
                        <OutlineBtn
                            onClick={() => {
                              this.props.history.push(
                                  `/classrooms/${this.props.match.params.coursesId}/exercises/${this.props.match.params.Id}/users/${this.props.current_user.login}`
                              );
                            }}
                        >
                          {exercise_status === 2 &&
                          start_Value[
                          Commonheadofthetestpaper &&
                          Commonheadofthetestpaper.user_permission
                              .current_status
                              ]}
                        </OutlineBtn>
                    )
                ) : null}
                {isAdmin === true ? (
                    <Spin spinning={this.state.donwloading}>
                      <style>
                        {`.NNNNN .ant-popover-inner-content{padding:0 0;box-shadow:0px 9px 28px 8px rgba(0,0,0,0.05),0px 6px 16px 0px rgba(0,0,0,0.08),0px 3px 6px -4px rgba(0,0,0,0.12);
border-radius:2px;} .NNNNN .ant-popover-inner{box-shadow:unset;}` }
                      </style>
                      <Popover
                          overlayClassName="NNNNN"
                          placement="bottom"
                          content={
                            <List>
                              <LstItem
                                  onClick={() =>
                                      this.confirmysl(
                                          `/exercises/${this.props.match.params.Id}/exercise_lists.xlsx`,
                                          this.child
                                      )
                                  }
                              >
                                学生成绩
                              </LstItem>
                              {/*<LstItem*/}
                              {/*    onClick={() =>*/}
                              {/*        window.open(*/}
                              {/*            getRandomcode(*/}
                              {/*                `/api/exercises/${this.props.match.params.Id}/export_exercise`*/}
                              {/*            )*/}
                              {/*        )*/}
                              {/*    }*/}
                              {/*>*/}
                              {/*  空白试卷*/}
                              {/*</LstItem>*/}
                            </List>
                          }
                      >
                        <OutlineBtn>
                          <Icon>&#xe75f;</Icon>&nbsp;导出
                        </OutlineBtn>
                      </Popover>
                    </Spin>
                ) : null}
              </BtnGrp>
            </Box>

            <DownloadMessageysl
                {...this.props}
                value={this.state.DownloadMessageval}
                modalCancel={this.Downloadcal}
                modalsType={this.state.DownloadType}
            />
            {
              // 教师列表
              parseInt(tab) == 0 ? (
                  this.props.isAdmin() &&
                  Commonheadofthetestpaper &&
                  (Commonheadofthetestpaper.exercise_status == 3 ||
                      Commonheadofthetestpaper.exercise_status == 4 ||
                      Commonheadofthetestpaper.exercise_status == 2) ? (
                      <HooksMocker {...this.props}>
                        <AnsLst
                            {...Commonheadofthetestpaper}
                        />
                      </HooksMocker>
                  ) : (
                      <Studentshavecompletedthelist
                          {...this.props}
                          {...this.state}
                          assistant_auth={assistant_auth}
                          triggerRef={this.bindRef}
                          setcourse_groupysls={(value) =>
                              this.setcourse_groupysls(value)
                          }
                          current_status={this.state.current_status}
                          Commonheadofthetestpaper={this.state.Commonheadofthetestpaper}
                          yslstustate={[
                            `${
                                polls_status[
                                Commonheadofthetestpaper &&
                                Commonheadofthetestpaper.exercise_status
                                    ]
                            }`,
                          ]}
                      />
                  )
              ) : null
            }

            {/*统计结果*/}
            {parseInt(tab) == 1 ? (
                <Exercisestatisticalresult
                    {...this.props}
                    {...this.state}
                    assistant_auth={assistant_auth}
                    triggerRef={this.bindRef}
                ></Exercisestatisticalresult>
            ) : null}

            {/*{parseInt(tab) == 2 ? (*/}
            {/*    <ExerciseDisplay*/}
            {/*        {...this.props}*/}
            {/*        {...this.state}*/}
            {/*        assistant_auth={assistant_auth}*/}
            {/*        triggerRef={this.bindRef}*/}
            {/*    ></ExerciseDisplay>*/}
            {/*) : null}*/}
            {parseInt(tab) == 2 ? (
                <WrappedExercisesetting
                    Commonheadofthetestpaper={this.state.Commonheadofthetestpaper}
                    {...this.props}
                    {...this.state}
                    assistant_auth={assistant_auth}
                    triggerRef={this.bindRef}
                    Commonheadofthetestpapers={this.Commonheadofthetestpaper}
                    assistantauthoritys={(bool) => this.assistantauthoritys(bool)}
                ></WrappedExercisesetting>
            ) : null}
          </Paper>
        </Background>
    );
  }
}

export default Testpapersettinghomepage;
