import React, { useState, useEffect } from 'react';
import axios from "axios";
import { Col, Row, Form, Input, Button, notification, InputNumber, Divider, Radio } from 'antd';
import { createForm } from 'rc-form';

const styles = {
    type: {
        fontSize: 14,
        color: "black",
        // margin: "0px 0 0 0 "
    },
    ml10: {
        marginLeft: 10
    },
    pt10: {
        paddingTop: 10
    },
    pt20: {
        paddingTop: 20
    },
    mr10: {
        marginRight: 10
    },
    mrb10: {
        margin: "0 10px 10px 0"
    },
    mtb10: {
        margin: "10px 0"
    },
    desc: {
        fontSize: 16,
        color: "#111"
    },
    itemWrp: {
        display: "flex"
    },
    item: {
        display: "flex",
        marginTop: 10,
        flex: 1
    },
    itemLeft: {
        lineHeight: 1.2,
        paddingRight: 8,
        color: "#000"
    },
    toaster: {
        fontSize: 12,
        color: "#999"
    },
    inputNumber: {
        height: 32,
        marginLeft: 8
    },
    red: {
        color: "#f5222d"
    }
}
const numberFormatter = (number) => {
    if (!number || Number.isNaN(Number(number))) {
        return "";
    } else {
        return Math.ceil(number);
    }
};
class CreateForm extends React.Component {
    state = {
        params: {
            contents: {}
        }
    }

    constructor() {
        super();
    }

    componentDidMount() {

    }

    shouldComponentUpdate(nextProps, nextState, nextContext) {
        return true
    }

    handleSubmit = e => {
        e.preventDefault();
        let { params } = this.state;
        this.props.form.validateFields((err, values) => {
            if (!err) {
                let data = Object.assign({}, params, values)
                data.contents = [];
                data["score_settings"] = [];
                Object.keys(params["contents"]).forEach(v => {
                    if (params["contents"][v]['score'])
                        data["score_settings"].push({
                            item_type: v,
                            score: params["contents"][v]['score'],
                        })
                })
                try {
                    Object.keys(params["contents"]).forEach(v => {
                        if (params["contents"][v]["count"]) {
                            Object.keys(params["contents"][v].sub_discipline_id).forEach(value => {
                                let key = params["contents"][v]["sub_discipline_id"][value];
                                Object.keys(key).forEach(val => {
                                    if (key[val].count)
                                        data["contents"].push({
                                            item_type: v,
                                            difficulty: key[val]["difficulty"],
                                            sub_discipline_id: value,
                                            items_count: key[val]["count"],
                                        })
                                })
                            })
                        }

                        // data["contents"].push({
                        //     item_type: v,
                        //     difficulty: params["contents"][v]["difficulty"],
                        //     sub_discipline_id: params["contents"][v]["sub_discipline_id"],
                        //     items_count: params["contents"][v]["items_count"],
                        // })
                    })
                } catch (e) {
                    debugger
                }
                delete data.score;
                this.putData(data)
            } else {
                notification.open({
                    message: '提示',
                    description: "请输入完整",
                    onClick: () => {
                        console.log('Notification Clicked!');
                    },
                });
            }
        });
    };


    async putData(data) {
        const d = await axios.put(`/exercises/${this.props.exercisesId}.json`, { ...data })

        if (d && d.data && d.data.status === 0) {
            notification.open({
                message: '提示',
                description: "保存成功",
                onClick: () => {
                    console.log('Notification Clicked!');
                },
            });
            window.location.href = `/classrooms/${this.props.coursesId}/exercises/${this.props.exercisesId}/student_exercise_random_detail?tab=0`
        } else {
            notification.open({
                message: '提示',
                description: "保存失败",
                onClick: () => {
                    console.log('Notification Clicked!');
                },
            });
        }
        console.log("d:", d)
    }

    getItemType = type => {
        switch (type) {
            case "SINGLE":
                return "单选题"
            case "MULTIPLE":
                return "多选题";
            case "JUDGMENT":
                return "判断题"
            case "COMPLETION":
                return "填空题"
            case "SUBJECTIVE":
                return "简答题"
            case "PRACTICAL":
                return "实训题"
            case "PROGRAM":
                return "编程题"
        }
    }

    handleChange = (value, type, key, val) => {
        const { params } = this.state;
        params.contents[type][val] = params.contents[type][val] || {}
        params.contents[type][val]["items_count"] = val;
        console.log("handleChange:", params)
        this.setState({ params }, () => {
            this.calc({
                items_type: type,
                difficulty: key,
                sub_discipline_id: val,
                value: value,
                type: 2
            })
        })
    }

    handleChangeScore = (value, type) => {
        const { params } = this.state;
        params.contents[type]["score"] = value;
        this.setState({ params }, () => {
            this.calcScore()
        })
    }

    calc(obj) {
        const { params } = this.state;
        let type = "add";
        var val = params.contents[obj.items_type].sub_discipline_id[obj.sub_discipline_id][obj.difficulty]["count"] || 0;
        if (obj.value < val) type = "min";
        params.contents[obj.items_type].count = 0;
        params.contents[obj.items_type].sub_discipline_id[obj.sub_discipline_id][obj.difficulty]["count"] = obj.value;
        Object.keys(params.contents[obj.items_type]["sub_discipline_id"]).forEach(v => {
            Object.keys(params.contents[obj.items_type]["sub_discipline_id"][v]).forEach(val => {
                if (params.contents[obj.items_type].sub_discipline_id[v][val]["count"])
                    params.contents[obj.items_type].count += params.contents[obj.items_type].sub_discipline_id[v][val]["count"]
            })
        })

        this.setState({ params: params, lock: true }, () => {
            this.calcScore()
        })
    }

    calcScore() {
        const { params } = this.state;
        let totalScore = 0;
        Object.keys(params.contents).forEach(v => {
            if (params.contents[v]["count"] && params.contents[v]["score"])
                totalScore += params.contents[v]["count"] * params.contents[v]["score"]
        })
        params.totalScore = totalScore;
        this.setState({ params: params, lock: true })
    }


    render() {
        const { params, lock } = this.state;
        const { getFieldDecorator } = this.props.form;
        const { exerciseData, optinalItems } = this.props;
        let { exercise, exercise_questions, score_settings, contents, all_sub_disciplines } = exerciseData;
        let items = {};
        if (!lock) params["totalScore"] = 0;
        if (!lock) {
            if (!params["score"] && score_settings) {
                params['score'] = {};
                score_settings.forEach(v => {
                    params["score"][v.item_type] = v.score
                })

            }
            score_settings && score_settings.forEach(v => {
                items[v.item_type] = items[v.item_type] || {};
                items[v.item_type]['score'] = v.score
            })
            optinalItems.contents && optinalItems.contents.forEach(val => {
                items[val.item_type] = items[val.item_type] || {};
                items[val.item_type]["items_count"] = 0;
                items[val.item_type]["hide"] = true;
                items[val.item_type]["sub_discipline_id"] = items[val.item_type]["sub_discipline_id"] || {};
                val.items_by_item_type && val.items_by_item_type.map(v => {
                    items[val.item_type]["sub_discipline_id"][v.sub_discipline_id] = items[val.item_type]["sub_discipline_id"][v.sub_discipline_id] || {}
                    v.items_by_item_type_and_sub_discipline && v.items_by_item_type_and_sub_discipline.map(function (value) {
                        items[val.item_type]["sub_discipline_id"][v.sub_discipline_id][value.difficulty] = value;
                        items[val.item_type]["sub_discipline_id"][v.sub_discipline_id][value.difficulty]["hide"] = true
                        items[val.item_type]["items_count"] += (value.items_count || 0)
                        // if (items[val.item_type]["score"] && !lock)
                        // params["totalScore"] += (value.items_count || 0) * items[val.item_type]["score"]
                    })
                })
            })

            optinalItems.contents && contents && contents.forEach(v => {
                try {
                    if (v.quanlity) {
                        items[v.item_type]["hide"] = false
                        items[v.item_type]["sub_discipline_id"][v.sub_discipline_id][v.difficulty]["hide"] = false
                        params["totalScore"] += (v.quanlity || 0) * items[v.item_type]["score"]

                    }
                    items[v.item_type]["count"] = items[v.item_type]["count"] || 0
                    items[v.item_type]["count"] += (v.quanlity || 0)
                    items[v.item_type]["sub_discipline_id"][v.sub_discipline_id][v.difficulty]["count"] = v.quanlity
                    items[v.item_type]["sub_discipline_id"][v.sub_discipline_id][v.difficulty]["default_count"] = v.quanlity
                } catch (e) {
                }
            });

            params.contents = items;
            console.log(params.contents, '----')
        }
        return <React.Fragment>
            <Form className="ant-advanced-search-form"
                style={styles.pt10}
                onSubmit={this.handleSubmit}
            >
                <style>
                    {
                        `
                    .courseForm .ant-input-number-input{
                        height:32px;
                        line-height:32px
                    }
                    `
                    }
                </style>
                <section
                    style={{ width: "60%", margin: "20px auto" }}
                >
                    <Row>
                        <Col span={24}>
                            <Form.Item label={`试卷标题 `}>
                                {getFieldDecorator(`exercise_name`, {
                                    initialValue: exercise.exercise_name,
                                    rules: [
                                        {
                                            required: true,
                                            message: '请输入试卷标题',
                                        },
                                    ],
                                })(<Input disabled={exercise.exercise_status !== 1} placeholder="请输入" max={20} min={0} />)}
                            </Form.Item>
                        </Col>
                        <Col span={24}>
                            <Form.Item label={`考试时长`}>
                                {getFieldDecorator(`time`, {
                                    initialValue: exercise.time,
                                    rules: [
                                        {
                                            required: true,
                                            pattern: new RegExp(/^[1-9]\d*$/, "g"),
                                            message: '请输入考试时长',
                                        },
                                        
                                    ],
                                })( <InputNumber
                                    min={1}
                                    max={9999}
                                    formatter={numberFormatter}
                                    placeholder="请输入试卷考试时长"
                                    style={{ width: 150 }}
                                  />)}
                                            <span style={{ marginLeft: 8 }}>分钟</span>

                            </Form.Item>

                        </Col>
                        <Col span={24}>
                            <Form.Item label="试卷难度">
                                {getFieldDecorator('difficulty', {
                                    initialValue: exercise.difficulty + "",
                                    rules: [{
                                        required: true,
                                        message: "请选择考试难度"
                                    }]
                                })(
                                    <Radio.Group disabled={exercise.exercise_status !== 1}>
                                        <Radio.Button value="1">简单</Radio.Button>
                                        <Radio.Button value="2" style={styles.ml10}>适中</Radio.Button>
                                        <Radio.Button value="3" style={styles.ml10}>困难</Radio.Button>
                                    </Radio.Group>,
                                )}
                            </Form.Item>
                        </Col>
                        <Col span={24}>
                            <Form.Item label="考察范围">
                                {getFieldDecorator('radio-button')(
                                    <Radio.Group>
                                        {
                                            all_sub_disciplines && all_sub_disciplines.map(function (val, key) {
                                                return <Radio.Button key={key} disabled={true}
                                                    style={styles.mrb10}>{val.sub_discipline_name}</Radio.Button>
                                            })
                                        }
                                    </Radio.Group>,
                                )}
                            </Form.Item>
                        </Col>
                        <Col span={24} style={styles.mtb10}>
                            <div style={styles.desc}><span style={styles.red}>*</span>题目题量编辑</div>
                        </Col>
                        {
                            contents && contents != '' && optinalItems && optinalItems.contents.map(function (v, _key) {
                                if (params.contents[v.item_type]["hide"]) return null;
                                return <div key={_key}>
                                    <Col span={24}>
                                        <aside style={styles.type}>
                                            {this.getItemType(v.item_type)}（已选{params.contents[v.item_type]['count']}题）
                                            <span style={styles.ml10}>
                                                <InputNumber
                                                    disabled={exercise.exercise_status !== 1}
                                                    onChange={(value) => {
                                                        this.handleChangeScore(value, v.item_type)
                                                    }}
                                                    style={styles.inputNumber}
                                                    min={0}
                                                    max={2000}
                                                    defaultValue={params.contents[v.item_type]["score"] || 0}
                                                />
                                                <span style={styles.ml10}>(分/题)</span>
                                            </span>
                                        </aside>
                                        <section key={_key}>

                                            {
                                                v.items_by_item_type.map(function (val, key) {
                                                    let isShow = val.items_by_item_type_and_sub_discipline.some(v =>
                                                        v.default_count > 0
                                                    )
                                                    if(!isShow) return null
                                                    return <div style={styles.pt20}>
                                                        <div style={styles.desc}>{
                                                            <span>{val["discipline_name"]}/{val["sub_discipline_name"]}</span>}
                                                        </div>
                                                        <section style={styles.itemWrp}>
                                                            {
                                                                val.items_by_item_type_and_sub_discipline.map(function (_v, _k) {
                                                                    if (!_v["default_count"]) return null
                                                                    return <aside style={styles.item} key={_k}>
                                                                        <div style={styles.itemLeft}>
                                                                            {_v["difficulty"] === 1 && "简单"}
                                                                            {_v["difficulty"] === 2 && "适中"}
                                                                            {_v["difficulty"] === 3 && "困难"}
                                                                            <br />
                                                                            <span
                                                                                style={styles.toaster}>(共 {_v["items_count"]} 题可选)</span>
                                                                        </div>
                                                                        <div>
                                                                            <InputNumber
                                                                                disabled={exercise.exercise_status !== 1}
                                                                                onChange={(value) => {
                                                                                    this.handleChange(value, v.item_type, _v["difficulty"], val["sub_discipline_id"])
                                                                                }}
                                                                                style={styles.inputNumber}
                                                                                min={0}
                                                                                max={_v["items_count"]}
                                                                                defaultValue={params.contents[v.item_type]["sub_discipline_id"][val.sub_discipline_id][_v.difficulty]["count"] || 0}
                                                                            />
                                                                        </div>
                                                                    </aside>
                                                                }.bind(this))
                                                            }
                                                        </section>
                                                    </div>
                                                }.bind(this))
                                            }

                                        </section>


                                    </Col>
                                    <Divider style={{ display: "inline-block" }} />
                                </div>

                            }.bind(this))
                        }

                    </Row>
                </section>
                <Divider style={{ display: "inline-block" }} />
                <Row
                    style={{ width: "60%", margin: "0px auto", paddingBottom: 20 }}
                >
                    <Col span={16}>
                        当前本卷总分 {params["totalScore"]} 分
                    </Col>
                    {
                        exercise.exercise_status === 1 && <Col span={8} className={"text-al"}
                            style={{ textAlign: "right" }}
                        >
                            <Button style={styles.ml10} onClick={() => {
                                // window.history.back()
                                window.location.href = `/classrooms/${this.props.coursesId}/exercises/${this.props.exercisesId}/student_exercise_random_detail?tab=0`
                            }}>取消</Button>
                            <Button style={styles.ml10} type={"primary"} htmlType={"submit"}>确定</Button>
                        </Col>
                    }

                </Row>
            </Form>
        </React.Fragment>
    }
}

const TextareaItemExampleWrapper = Form.create({})(CreateForm);

class FormEdit extends React.Component {
    state = {
        exerciseData: {
            exercise: {},
            exercise_questions: {},
            exercise_types: {}
        },
        optinalItems: {
            contents: []
        }
    }

    constructor() {
        super();
    }

    componentDidMount() {
        this.getData()
    }

    async getData() {
        const d = await axios.get((`/exercises/${this.props.match.params.Id}/edit.json`), {})
            .then(response => {
                // this.setState({exerciseData: response.data});
                return response.data
            })
            .catch(data => {
            });
        const sub_discipline_id = [];
        d.all_sub_disciplines.forEach(v => sub_discipline_id.push(v.sub_discipline_id))
        axios.post('/examination_intelligent_settings/optinal_items.json', {
            sub_discipline_id: sub_discipline_id,
            source: d.exercise.source === 0 ? 2 : 0
        }).then(res => {
            this.setState({ optinalItems: res.data, exerciseData: d })
        })
    }

    render() {
        return <div
            style={{ background: '#FFF' }}
        >
            <style>
                {
                    `
                .ant-advanced-search-form .ant-form-item{
                    margin-bottom:0
                }
                .courseForm .ant-form-item-label{
                    margin-left:0
                }
                .ant-form label{
                    font-size:14px !important;
                }
                `
                }
            </style>
            <TextareaItemExampleWrapper ref="form"
                coursesId={this.props.match.params.coursesId}
                exercisesId={this.props.match.params.Id}
                exerciseData={this.state.exerciseData}
                optinalItems={this.state.optinalItems}
            />

        </div>
    }


}

export default FormEdit;