import React, { Component } from "react";
import { Spin, Popover } from "antd";
import { queryString, getRandomcode } from "educoder";
import "../../css/members.css";
import "../../css/busyWork.css";
import axios from "axios";
import Modals from "../../../modals/Modals";
import DownloadMessageysl from "../../../modals/DownloadMessageysl";
import Studentshavecompletedthelist from "./../Studentshavecompletedthelist";
import WrappedExercisesetting from "./../Exercisesetting";
import ExerciseDisplay from "./../ExerciseDisplay";
//固定选题统计结果
import Exercisestatisticalresult from "./../Exercisestatisticalresult";
//随机统计结果组件
import RandomSstatistics from "./../RandomSstatistics";
import ImmediatelyPublish from "../../poll/pollPublicBtn/ImmediatelyPublish";
import ImmediatelyEnd from "../../poll/pollPublicBtn/ImmediatelyEnd";
import Ecerciseallbackagain from "./../Ecerciseallbackagain";

import { Link } from "react-router-dom";
import Menu from "./../util/widget/Menu";
import {
  Background,
  BetweenBox,
  FlexBox,
  Paper,
} from "./../util/layout";
import { IconBtn } from "./../util/widget/button";
import { Title } from "./../util/widget/typography";
//import Popover from "./util/widget/Popover";
import StatusTag from "./../util/widget/StatusTag";
import Nav from "./../util/widget/Nav";
import { OutlineBtn } from "./../util/widget/button";
import { List, LstItem } from "./../util/widget/lst";
import styled from "styled-components";
import {AllCenterMixin, FontMixinGen} from "./../util/cssMixin";

const BtnGrp = styled.div`
  display: flex;
  & > div:not(:last-child) {
    margin-right: 8px;
  }
`;
const Box = styled(BetweenBox)`
  padding: 0 24px;
  height: 64px;
  border-bottom: 1px solid rgba(0, 0, 0, 0.06);
`;

const polls_status = { 1: "未发布", 2: "考试中", 3: "已截止", 4: "已结束" };
const start_Value = { 0: "继续答题", 1: "查看答题", 2: "开始答题" };
const qs = require("qs");
//试卷主要设置页面
class Testpapersettinghomepage extends Component {
  constructor(props) {
    super(props);
    this.state = {
      tab: 0,
      searchtext: "",
      Commonheadofthetestpaper: undefined,
      visible: false,
      groupyslsval: "",
      current_status: undefined,
      DownloadType: false,
      DownloadMessageval: undefined,
      donwloading: false,
      exercise_status: 3,
      assistant_auth: false, //设置助教
    };
  }
  //切换tab
  changeTab = (e, s) => {
    if (typeof s == "number") {
      this.setState({
        tab: s,
      });
    } else {
      this.setState({
        tab: e.key,
      });
    }
  };
  componentDidMount() {
    const query = this.props.location.search;
    const type = query.split("?tab=");
    this.setState({
      tab: parseInt(type[1]),
    });
    this.Commonheadofthetestpaper();
  }
  //试卷公用头部
  Commonheadofthetestpaper = () => {
    var exercise_id = this.props.match.params.Id;
    var url = `/exercises/${exercise_id}/common_header.json`;
    axios
      .get(url)
      .then((response) => {
        try {
          if (response.status === 200) {
            response.data.is_random = true
            this.setState({
              Commonheadofthetestpaper: response.data,
              current_status: response.data.user_permission.current_status,
              exercise_status: response.data.exercise_status,
              assistant_auth: response.data.assistant_auth,
            });
          }
        } catch (e) {}
      })
      .catch((error) => {
        console.log(error);
      });
  };

  assistantauthoritys = (bool) => {
    this.setState({
      assistant_auth: bool,
    });
  };

  Ecerciseacallagain = () => {
    this.setState({
      visible: true,
    });
  };
  callback = (val) => {
    this.setState({
      visible: false,
    });
    if (val === 1) {
      window.location.reload();
    }
  };

  moveTos = (val) => {
    if (val === 0) {
    }
  };

  setcourse_groupysls = (val) => {
    let list = "";
    val.map((item, key) => {
      if (item !== undefined) {
        list = list + "&exercise_group_id[]=" + item;
      }
    });
    this.setState({
      groupyslsval: list,
    });
  };
  setgameexercise = (url) => {
    let { Commonheadofthetestpaper } = this.state;
    if (Commonheadofthetestpaper.time > 0) {
      this.setState({
        Modalstype: true,
        ModalSave: () => this.props.history.push(url),
        Modalstopval: `答题时长限制${Commonheadofthetestpaper.time}分钟，从首次答题开始实行不间断计时`,
        modalsBottomval: "请确认是否有充足的答题时间？",
      });
    } else {
      this.setState({
        Modalstype: true,
        ModalSave: () => this.props.history.push(url),
        Modalstopval: "是否确认开始答题？",
        modalsBottomval: " ",
      });
    }
  };
  //打开pdf
  confpdf = (url) => {
    window.open(url);
  };
  /// 确认是否下载
  confirmysl(url, child) {
    let params = {};
    if (child != undefined) {
      params =
        child._getRequestParams() !== undefined
          ? child._getRequestParams()
          : {};
    }

    const urll = url + `?${queryString.stringify(params)}`;

    axios
      .get(urll + "&export=true")
      .then((response) => {
        if (response === undefined) {
          return;
        }
        if (response.data.status && response.data.status === -1) {
        } else if (response.data.status && response.data.status === -2) {
          if (response.data.message === "100") {
            // 已超出文件导出的上限数量（100 ），建议：

            this.setState({
              DownloadType: true,
              DownloadMessageval: 100,
            });
          } else {
            //因附件资料超过500M
            this.setState({
              DownloadType: true,
              DownloadMessageval: 500,
            });
          }
        } else {
          this.props.slowDownload(getRandomcode(urll));
        }
      })
      .catch((error) => {
        console.log(error);
      });
  }

  Downloadcal = () => {
    this.setState({
      DownloadType: false,
      DownloadMessageval: undefined,
    });
  };
  cancelmodel = () => {
    this.setState({
      Modalstype: false,
      ModalSave: " ",
      Modalstopval: " ",
      modalsBottomval: " ",
      Loadtype: false,
    });
  };
  getsetdata = () => {
    let { tab } = this.state;
    try {
      if (tab === "0") {
        this.child.Teacherliststudentlist();
      }
      if (tab === "1") {
        this.child.Teacherliststudentlist();
      }
      if (tab === "2") {
        this.child.Teacherliststudentlist();
      }
      if (tab === "3") {
        this.child.getSettingInfo();
      }
    } catch (e) {}
  };
  bindRef = (ref) => {
    this.child = ref;
  };
  goback = () => {
    // }
    this.props.history.goBack();
  };
  render() {
    let {
      tab,
      visible,
      Commonheadofthetestpaper,
      exercise_status,
      assistant_auth,
    } = this.state;
    const isAdmin = this.props.isAdmin();
    const isAssistant = this.props.isAssistant();
    const isStudent = this.props.isStudent();
    // TODO
    const [coursesId, exerciseId] = [
      this.props.match.params.coursesId,
      this.props.match.params.Id,
    ];
    const map1 = { 答题列表: 0, 统计结果: 1, 试卷预览: 2, 设置: 3 };
    const map2 = ["答题列表", "统计结果", "试卷预览", "设置"];
    const calc = () => {
      if(Commonheadofthetestpaper && Commonheadofthetestpaper.is_random){
        return ["答题列表", "统计结果","试卷预览", "设置"]
      }
      if ((isAssistant && assistant_auth) || isAdmin) {
        return ["答题列表", "统计结果", "试卷预览", "设置"];
      }
      if (
        Commonheadofthetestpaper &&
        Commonheadofthetestpaper.show_statistic &&
        Commonheadofthetestpaper.exercise_status === 3
      ) {
        return ["答题列表", "统计结果", "设置"];
      }
      return ["答题列表", "设置"];
    };
    debugger

    const menuArr = calc();
    console.log("Commonheadofthetestpaper:",Commonheadofthetestpaper,polls_status)
    document.title = this.props.coursedata && this.props.coursedata.name;
    return (
      <Background>
        {/* 公用的提示弹框 */}
        {this.state.Modalstype === true ? (
          <Modals
            modalsType={this.state.Modalstype}
            modalsTopval={this.state.Modalstopval}
            modalsBottomval={this.state.modalsBottomval}
            loadtype={this.state.Loadtype}
            modalCancel={this.cancelmodel}
            modalSave={this.state.ModalSave}
            antIcon={this.state.Modalstypeloding}
          ></Modals>
        ) : null}
        {visible === true ? (
          <Ecerciseallbackagain
            {...this.props}
            modalname={"打回重做"}
            visible={visible}
            callback={this.callback}
          />
        ) : null}
        <Nav
          items={[
            <Link to={`/classrooms/${coursesId}`}>
              {this.props.coursedata.name}
            </Link>,
            <Link
              to={`/classrooms/${coursesId}/exercises/${
                Commonheadofthetestpaper &&
                Commonheadofthetestpaper.user_permission.left_banner_id
              }`}
            >
              试卷
            </Link>,
            "试卷详情",
          ]}
        />
        <FlexBox style={{ margin: "15px 0", alignItems: "center" }}>
          <IconBtn
            style={{ margin: "0 5px" }}
            type="arrow-left"
            onClick={() =>
              this.props.history.push(
                `/classrooms/${coursesId}/exercises/${
                  Commonheadofthetestpaper &&
                  Commonheadofthetestpaper.user_permission.left_banner_id
                }`
              )
            }
          />
          <Title style={{ margin: "0 5px" }}>
            {Commonheadofthetestpaper && Commonheadofthetestpaper.exercise_name}
          </Title>
          <span style={{
            background:"#028D01",
            height: 20,
            minWidth: 68,
            borderRadius: 10,
            userSelect: "none",
            textAlign:"center",
            lineHeight:"20px",
            margin:"0 5px",
            fontSize:12,
            color: "#fff"
          }}>随机</span>
          <StatusTag
            type={`${
              polls_status[
                Commonheadofthetestpaper &&
                  Commonheadofthetestpaper.exercise_status
              ]
            }`}
          />
        </FlexBox>

        <Paper>

          <DownloadMessageysl
            {...this.props}
            value={this.state.DownloadMessageval}
            modalCancel={this.Downloadcal}
            modalsType={this.state.DownloadType}
          />

          <ExerciseDisplay
              {...this.props}
              {...this.state}
              assistant_auth={assistant_auth}
              triggerRef={this.bindRef}
          ></ExerciseDisplay>
        </Paper>
      </Background>
    );
  }
}

export default Testpapersettinghomepage;
