import React, { Component } from "react";
import { Checkbox, Pagination } from "antd";
import axios from 'axios';
import ReactEcharts from "echarts-for-react";
import Exercisetablesmubu from './Exercisetablesmubu';
import Exercisestatisticalresulttabel from './Exercisestatisticalresulttabel';

import '../css/members.css';
import '../css/busyWork.css';
import '../poll/pollStyle.css';
import './yslexercisetable.css'
import RenderHtml from "../../../components/render-html";


const CheckboxGroup = Checkbox.Group;
const $ = window.$
function createMarkup(value) { return { __html: value } };
function getnum(num)
{
  let re = /([0-9]+\.[0-9]{1})[0-9]*/;
  return (num + "").replace(re,"$1");
}
class Exercisestatisticalresult extends Component {

	constructor(props) {
		super(props);
		this.state = {
			data: undefined,
			sort: "asc",
			exercise_group_id: [],
			page: 1,
			limit: 10,
			searchtext: "",
			order: "end_at",


		}
	}

	componentDidMount() {
		let { sort, exercise_group_id, page, limit } = this.state;
		this.updatefun(sort, exercise_group_id, page, limit);
		try {
			this.props.triggerRef(this);
		} catch (e) {

		}
	}
	_getRequestParams() {
		const { order, exercise_group_id, searchtext, page, limit } = this.state
		return {
			page,
			search: searchtext,
			order,
			limit: limit,
			group_id: exercise_group_id,
		}
	}
	updatefun = (sort, exercise_group_id, page, limit) => {
		let ExerciseId = this.props.match.params.Id;
		let url = `/exercises/` + ExerciseId + `/exercise_result.json?`;
		axios.get(url, {
			params: {
				sort: sort,
				exercise_group_id: exercise_group_id,
				page: page,
				limit: limit
			}
		}).then((result) => {
			this.setState({
				data: result.data
			})
		}).catch((error) => {
			console.log(error)
		})
	}


	onSortTypeChange = () => {
		let { exercise_group_id, page, limit, sort } = this.state;
		let newdesc = "asc";
		if (sort === "desc") {
			newdesc = "asc"
		} else {
			newdesc = "desc"
		}
		this.setState({
			sort: newdesc
		})

		this.updatefun(newdesc, exercise_group_id, page, limit)
	}

	funtaskstatustwo = (checkedValues, list) => {

		let { sort, page, limit } = this.state;
		// if(checkedValues.length===list.length){
		// 	this.setState({
		// 		exercise_group_id:[]
		// 	})
		// }else{
		//
		// }
		this.setState({
			exercise_group_id: checkedValues
		})
		this.updatefun(sort, checkedValues, page, limit)
	}

	alldatalist = () => {
		let { sort, page, limit } = this.state;
		this.setState({
			exercise_group_id: []
		})
		this.updatefun(sort, [], page, limit)
	}
	PaginationCourse = (pageNumber) => {
		let { sort, exercise_group_id, limit } = this.state;

		this.setState({
			page: pageNumber
		})

		$('html').animate({
			scrollTop: 10
		}, 1000);
		this.updatefun(sort, exercise_group_id, pageNumber, limit)

	}

	getCommitType = v => {
		switch (v) {
			case 0:
				return "单选题";
			case 1:
				return "多选题";
			case 2:
				return "判断题";
			case 3:
				return "填空题";
			case 4:
				return "简答题";
			case 5:
				return "实训题";
			case 6:
				return "编程题";
		}
	}

	getOption(v) {
		return {
			title: {
				text: '『 学生正确率分布图 』',
				// subtext: '虚构数据',
				left: 'center'
			},
			tooltip: {
				trigger: 'item',
				formatter: '{b} : {c} 人'
			},
			legend: {
				bottom: 0,
				icon: "circle",
				left: 'center',
				itemWidth: 6,
				itemHeight: 6,
				data: ['100%', '90%-100%', '70%-90%', '60%-70%', '60%以下'].reverse()
			},
			series: [
				{
					type: 'pie',
					radius: '55%',
					minAngle: 15,
					center: ['50%', '50%'],
					selectedMode: 'single',
					label: {
						show: true,
						position: "outer",
						normal: {
							formatter: '{b} \n {c}人',
							color: "#5c5c5c",
							lineHeight: 20
						}
					},
					labelLine: {
						normal: {
							length: 20,
							length2: 20,
							lineStyle: {
								color: 'rgba(0,0,0,.45)'
							}
						}
					},
					data: [
						{
							value: v.details[0].full_count,
							name: '100%',
						},
						{ value: v.details[0].best_count, name: '90%-100%' },
						{ value: v.details[0].good_count, name: '70%-90%' },
						{ value: v.details[0].pass_count, name: '60%-70%' },
						{ value: v.details[0].fails_count, name: '60%以下' }
					],
					itemStyle: {
						emphasis: {
							shadowBlur: 10,
							shadowOffsetX: 0,
							shadowColor: 'rgba(0, 0, 0, 0.5)'
						},
						normal: {
							color: function (params) {
								var colorList = [
									'#99B8FB', '#80E0B9', '#8190AA', '#F7C739', '#EB7E65'
								];
								return colorList[params.dataIndex]
							}
						}
					},
					emphasis: {
						itemStyle: {
							shadowBlur: 10,
							shadowOffsetX: 0,
							shadowColor: 'rgba(0, 0, 0, 0.5)'
						}
					}
				}
			]
		}
	}
	render() {
		let { data, sort, page, limit } = this.state;
		let choicetype = ["满分作答", "部分得分作答", "零分作答", "未批"]
		const DigitalConversion = ["一", "二", "三", "四", "五", "六"]
		return (
			<div className=" ">

				<style>
					{`
					 div{
					 color: rgba(0, 0, 0, 0.65);
					 }
					`}
				</style>

				<div className={"educontent mb30"} >
					{data && data.course_groups.length === 0 ? "" : <div className="stud-class-set">
						{/* <div className="clearfix edu-back-white">
							<ul className="clearfix" style={{ padding: '20px' }}>
								<li className="clearfix  mt10">
									<span className="fl mr10 color-grey-8">分班情况：</span>
									<span className="fl ">
										<a id="graduation_comment_no_limit"
											className={this.state.exercise_group_id.length === 0 ? "pl10 pr10 mr20 check_on" : "pl10 pr10 mr20"}
											onClick={() => this.alldatalist()}>全部</a>
									</span>
									<CheckboxGroup onChange={(e) => this.funtaskstatustwo(e, data && data.course_groups)} value={this.state.exercise_group_id} style={{ width: '87%', paddingTop: '4px' }}>
										{data && data.course_groups.map((item, key) => {
											return (
												<span key={key}>
													<Checkbox value={item.exercise_group_id}
														key={item.exercise_group_id}
														// checked={course_group_info === undefined ? false : course_group_info[key].course_group_id === item.course_group_id ? true : false}
														className="fl ">{item.exercise_group_name}
														<span>({item.exercise_group_students})</span>
													</Checkbox>
												</span>
											)
										})}
									</CheckboxGroup>
								</li>
							</ul>
						</div> */}
					</div>}

					<div className="stud-class-set">
						<div className="clearfix edu-back-white exerciseTable ">
							<Exercisestatisticalresulttabel
								data={data}
							/>
						</div>
					</div>
					<style>
						{`
						.fafafa{
						    background: #fafafa;
						    height:50px;
						  }
						  .drop_down_normal li{
    						text-align: center;
						  }
						  .mr33{
    						margin-right: 33px;
						  }
						 .fiilssort{
								 position: absolute;
								 top: -9px;
						  }
						`}
					</style>
					<div className="stud-class-set"
						style={{ display: "inline-block", width: "100%" }}
					>
						<li
							style={{
								fontSize: 20,
								color: "#000",
								fontWeight: 600,
								padding: "20px 20px 0 20px",
								background: "rgba(246,246,246,1)"
							}}
						>
							已交卷学生答题详情
						</li>
						{
							data && data.commit_results && data.commit_results.map(function (v, k) {
								return <div key={k} style={{ borderTop: "24px solid rgba(246,246,246,1)", padding: "16px 24px" }}>
									<div style={{ fontSize: 14, color: "#1890FF", fontWeight: 500 }}>
										{DigitalConversion[k]}、{this.getCommitType(v.question_type)}<span style={{ color: "#999", paddingLeft: 10 }}>(共{v.question_count}小题，{v.question_score}分)</span>
										<span style={{ color: "#000", float: "right" }}>全班正确率：{getnum(v.right_percent * 100)}%</span>
									</div>
									<ReactEcharts
										option={this.getOption(v)}
										style={{ height: 370 }}
										opts={{ renderer: 'svg' }} // use svg to render the chart.
									/>
								</div>
							}.bind(this))
						}

					</div>



				</div>


			</div>


		)
	}
}

export default Exercisestatisticalresult;



