import React, { useState } from 'react'
import { Input, Form, Button } from 'antd'
import './index.scss'
const formItemLayout = {
  labelCol: {
    xs: { span: 24 },
    sm: { span: 24 },
  },
  wrapperCol: {
    xs: { span: 24 },
    sm: { span: 24 },
  },
}
const { TextArea } = Input
const TITLE_MAX_LENGTH = 60

export default ({ exercise_name = '', exercise_description, is_md, onSaveHandler, isEdit, onCancel }) => {

  const [data, setData] = useState({
    exercise_name,
    exercise_description,
    is_md
  })

  function onChange(prop, value) {
    setData({ ...data, [prop]: value })
  }

  function onNameChange(e) {
    onChange('exercise_name', e.target.value)
  }

  function onDescChange(e) {
    onChange('exercise_description', e.target.value)
  }

  function onSave() {
    onSaveHandler(data)
  }

  return (
    <Form {...formItemLayout}>
      <div className='exercise-new-form'>
        <Form.Item label="试卷标题" required className="topicTitle " >
          <Input placeholder={`请输入试卷标题，最大限制${TITLE_MAX_LENGTH}个字符`} maxLength={TITLE_MAX_LENGTH} className="mt5 exercicenewinputysl" value={data.exercise_name}
            onChange={onNameChange} addonAfter={`${data.exercise_name.length}/${TITLE_MAX_LENGTH}`}
          />
        </Form.Item>
        <Form.Item label="&nbsp;&nbsp;试卷须知" >
          <TextArea placeholder="请在此输入本次试卷答题的相关说明，最大限制100个字符" maxLength={100} className="mt5" style={{ height: "120px" }} value={data.exercise_description} onChange={onDescChange} />
        </Form.Item>

        <Form.Item>
          <div className="btn-group">
            <Button size='default' type='primary' style={{ marginRight: 12 }} onClick={onSave}>保存</Button>
            {isEdit ? null : <Button size='default' type='ghost' onClick={onCancel}>取消</Button>}
          </div>
        </Form.Item>
      </div>

    </Form >

  )
}