import { Btn, Icon } from "../../util/widget";
import React from "react";
import { useHistory, useParams } from "../../util/hooks";
import { FlexBox, Margin } from "../../util/layout";

const { OutlineBtn } = Btn;

export default ({ data, filterCfg }) => {
  const history = useHistory();
  const { coursesId, Id: exerciseId } = useParams();
  const disable = data.total_exercise_users.length == 0;
  return (
    <FlexBox>
      <OutlineBtn
        disable={disable}
        onClick={() => {
          window.sessionStorage.setItem('userid',data.total_exercise_users.map((u) => u.user_id))
          history.push(`/classrooms/${coursesId}/exercises/${exerciseId}/group`)
          // history.push({
          //   pathname: `/classrooms/${coursesId}/exercises/${exerciseId}/group`,
          //   state: data.total_exercise_users.map((u) => u.user_id),
          // });
        }}
      >
        <Icon>&#xe764;</Icon>&nbsp;集中批量批阅
      </OutlineBtn>
      <Margin width="8px" />
      <OutlineBtn
        disable={disable}
        onClick={() => {
          //history.push(`/classrooms/${coursesId}/exercises/${exerciseId}/order/0`)
          history.push({
            pathname: `/classrooms/${coursesId}/exercises/${exerciseId}/order/0`,
            state: data.total_exercise_users,
          });
        }}
      >
        <Icon>&#xe766;</Icon>&nbsp;组内顺序批阅
      </OutlineBtn>
    </FlexBox>
  );
};
