import React, { useContext } from "react";
import { AllCheckGroup } from "../../util/widget";
import { UpdateCtx } from "../AnswerLst";

const cfg = [
  [
    ["你的评阅", "review"],
    [
      ["未评阅", "unreview_counts", 0],
      ["评阅中", "reviewing_counts", 2],
      ["已评阅", "review_counts", 1],
    ],
  ],
  [
    ["作品状态", "commit_status"],
    [
      ["未开始", "unanswer_users", 0],
      ["考试中", "answering_users", 1],
      ["已交卷", "answer_users", 2],
      ["已交卷/未答", "commit_with_no_answers_users", 3],
    ],
  ],
];

//

export default ({ filterCfg, data }) => {
  const dispatch = useContext(UpdateCtx);
  return (
    <React.Fragment>
      {cfg.map((c) => (
        <AllCheckGroup
          map={
            new Map(
              c[1].map(([str, props, code]) => [
                code,
                `${str}(${data.exercise_types[props]})`,
              ])
            )
          }
          value={filterCfg[c[0][1]]}
          onChange={(v) => {
            dispatch({
              type: c[0][1],
              payload: v,
            });
          }}
          label={c[0][0]}
        />
      ))}
      {data.exercise_types.groups_count!=0 && (
        <AllCheckGroup
          map={
            new Map(
              data.course_groups.map((g) => [
                g.exercise_group_id,
                `${g.exercise_group_name}(${g.exercise_group_students})`,
              ])
            )
          }
          value={filterCfg.exercise_group_id}
          onChange={(v) => {
            dispatch({
              type: "exercise_group_id",
              payload: v,
            });
          }}
          label="分班情况"
        />
      )}
    </React.Fragment>
  );
};
