import React, { useMemo, useContext } from "react";
import { Head } from "./style";
import { MiniSorter } from "../../util/widget";
import { UpdateCtx } from "../AnswerLst";
import { cfgFilter } from "./util";
import { FlexBox } from "../../util/layout";

export default ({ data, filterCfg }) => {
  const dispatch = useContext(UpdateCtx);
  const lstCfg = useMemo(() => cfgFilter(data), [data]);
  return (
    <Head lstCfg={lstCfg}>
      {lstCfg.map((i) => (
        <div key={i[0]} style={{width:"fit-content"}}>
          {i[0]}
          {i[1][1] && (
            <MiniSorter
              value={
                filterCfg.order == i[1][1] ? filterCfg.order_type : undefined
              }
              onChange={(v) => {
                dispatch({
                  type: "sort",
                  payload: {
                    order: v && i[1][1],
                    order_type: v,
                  },
                });
              }}
            />
          )}
        </div>
      ))}
    </Head>
  );
};
