import React, { useState } from "react";
import axios from "axios";
import { useLoaded, useParams } from "../../util/hooks";
import { Popover } from "../../util/widget";
import { Tooltip } from "antd";

const cfg = [
  ["single_question_score", "单选题"],
  ["multiple_question_score", "多选题"],
  ["judgement_question_score", "判断题"],
  ["completion_question_score", "填空题"],
  ["program_question_score", "编程题"],
  ["shixun_question_score", "实训题"],
];

export default ({ children, exercise_user }) => {
  const { Id } = useParams();
  const [data, setD] = useState(undefined);
  const str =
    data &&
    cfg
      .filter(([p]) => data[p] !== undefined)
      .map(([prop, name]) => `${name} ${data[prop]}分`)
      .join("\n");
  return (
    <div>
      <style>{`.JFKDKSHDKJ .ant-tooltip-inner{border-radius:2px;}`}</style>
      <Tooltip
        overlayClassName="JFKDKSHDKJ"
        placement="bottom"
        onVisibleChange={() => {
          if (data) {
            return;
          }
          if (exercise_user.user_id) {
            axios
              .get(`/exercises/${Id}/get_objective_scores.json`, {
                params: {
                  user_id: exercise_user.user_id,
                },
              })
              .then((r) => setD(r.data));
          }
        }}
        title={<pre style={{ margin: "4px 6px" }}>{str}</pre>}
      >
        {children}
      </Tooltip>
    </div>
  );
};
