const itemCfg = [
  ["序号", [2, false, "index"]],
  ["姓名", [2, false, "user_name"]],
  ["学号", [3, "student_id", "student_id"]],
  ["分班", [3, false, "user_group_name"]],
  ["提交状态", [3, false, "commit_status"]],
  ["提交时间", [4, "end_at", "end_at"]],
  ["客观题得分", [2, false, "objective_score"]],
  ["主观题得分", [3, false, "subjective_score"]],
  ["最终成绩", [2, "score", "score"]],
  ["评阅状态", [2, false, "review_status"]],
  ["操作", [2, false, "operate"]],
];

export const haveGroup = (data) => data.exercise_types.groups_count != 0;
export const haveSub = (data) => data.exercise_types.subjective ==1;
export const haveObj = (data) => data.exercise_types.objective ==1;

export const cfgFilter = (listData) => {
  return itemCfg.filter(([k, _]) => {
    if (!haveGroup(listData) && k == "分班") {
      return false;
    }
    if (!haveSub(listData) && k == "主观题得分") {
      return false;
    }
    if (haveSub(listData) && !haveObj(listData) && k == "主观题得分") {
      return false;
    }
    if (!haveSub(listData) && haveObj(listData) && k == "客观题得分") {
      return false;
    }
    if (!haveObj(listData) && k == "客观题得分") {
      return false;
    }
    return true;
  });
};

export const defaultObj = (cfg) => {
  const obj = {};
  for (const c of cfg) {
    obj[c[1][2]] = "-";
  }
  return obj;
};
