import React, {useEffect, createContext} from "react";
import {FlexBox} from "../util/layout";
import {useParams, useHistory} from "../util/hooks";
import {Nav, StatusTag, Typo, Btn} from "../util/widget";
import {Link} from "react-router-dom";

const statusMap = {1: "未发布", 2: "考试中", 3: "已截止"};
const {IconBtn} = Btn;
const {Title} = Typo;

export const UpdateCtx = createContext(null);

export default ({current_user, reviewData}) => {
    if (!reviewData) {
        return null;
    }
    const courseName = current_user.course_name;
    const {coursesId, Id: exerciseId} = useParams();
    const history = useHistory();
    useEffect(() => {
        if (courseName) {
            document.title = courseName;
        }
    }, [courseName]);
    let detailUrl = `/classrooms/${coursesId}/exercises/${exerciseId}/student_exercise_list?tab=0`
    if(reviewData.exercise.is_random){
        detailUrl = `/classrooms/${coursesId}/exercises/${exerciseId}/student_exercise_random_detail?tab=0`
    } 

    debugger;
    return (
        <React.Fragment>
            <Nav
                items={[
                    <Link to={`/classrooms/${coursesId}`}>{courseName}</Link>,
                    <Link
                        to={`/classrooms/${coursesId}/exercises/${reviewData.left_banner_id}`}
                    >
                        {reviewData.left_banner_name}
                    </Link>,
                    <Link
                        to={detailUrl}
                    >
                        {reviewData.left_banner_name}详情
                    </Link>,
                    <span>
            {(reviewData.exercise_answer_user &&
                reviewData.exercise_answer_user.user_name) ||
            "试卷详情"}
          </span>,
                ]}
            />
            <FlexBox style={{margin: "15px 0", alignItems: "center"}}>
                <IconBtn
                    style={{margin: "0 5px"}}
                    type="arrow-left"
                    onClick={() =>{
                        let url =  `/classrooms/${coursesId}/exercises/${exerciseId}/student_exercise_list?tab=0`;
                        if(reviewData.exercise.is_random){
                            url =  `/classrooms/${coursesId}/exercises/${exerciseId}/student_exercise_random_detail?tab=0`
                        }
                        history.push(
                           url
                        )
                    }
                        
                    }
                />
                <Title style={{margin: "0 5px"}}>
                    {reviewData.exercise.exercise_name}
                </Title>
                {
                    reviewData.exercise.is_random && <span style={{
                        width: 52,
                        height: 20,
                        lineHeight: "20px",
                        textAlign: "center",
                        background: "#84B6EB",
                        color: "#FFF",
                        borderRadius: 20,
                        fontSize: 12,
                        marginRight: 4
                    }}>随机</span>
                }
                <StatusTag type={`${statusMap[reviewData.exercise.exercise_status]}`}/>
            </FlexBox>
        </React.Fragment>
    );
};
