import React, { useCallback } from "react";
import { Row } from "./style";
import { GSubQuestionsStatus as Status } from "./quesStatus";
import Ques from "./Ques";

export default ({ reviewData }) => {
  const scrollToAnchor = useCallback((anchorName) => {
    setTimeout(() => {
      if (anchorName) {
        let anchorElement = document.getElementById(anchorName);
        if (anchorElement) {
          anchorElement.scrollIntoView({ block: "start", behavior: "smooth" });
        }
      }
    });
  }, []);
  return (
    <React.Fragment>
      <Row>
        <Status
          questions={reviewData.exercise_questions}
          exercise_status={reviewData.exercise.exercise_status}
          scrollToAnchor={scrollToAnchor}
        />
        {reviewData.exercise_questions.map((q) => (
          <Ques
            question={q}
            is_md={reviewData.exercise.is_md}
            isGroup
            exercise_answer_user={reviewData.exercise_answer_user}
            exercise={reviewData.exercise}
          />
        ))}
      </Row>
    </React.Fragment>
  );
};
