import React, { useReducer, createContext,useEffect,useState } from "react";
import axios from "axios";
import { Background, Paper } from "../util/layout";
import { useParams, useLoaded, useLocation, HooksMocker,useHistory } from "../util/hooks";
import Content from "./GroupContent";
import Head from "./GroupHead";
import update from "immutability-helper";
import Nav from "./CommonNav";
import { Spin } from "antd";
export const UpdateCtx = createContext(null);



const Inner = ({ current_user}) => {
  

  const { Id: exerciseId, coursesId} = useParams();
  //const userIds = useLocation().state;
  const history = useHistory();
  const [isloading, setisloading] = useState(true);
  const [userIds, setuserIds] = useState([]);


  const [reviewData, dispatch] = useReducer((state, action) => {
    switch (action.type) {
      case "init":   
        setisloading(false);
        return action.payload;
      case "update":
        setisloading(false);
        const idx = state.exercise_questions.findIndex(
          (q) => q.q_position === action.payload.q_position
        );
        return update(state, {
          exercise_questions: {
            [idx]: { $set: action.payload },
          },
        });
        case "isloading":
          //console.log("11111111111111111");
           setisloading(true)
          return {...state};
      default:
        return;
    }
  });
  const { isLoaded } = useLoaded(async () => {
    
    if(!window.sessionStorage.getItem('userid')){
      history.push(`/classrooms/${coursesId}/exercises/${exerciseId}/student_exercise_list?tab=0`)
      return
    }
    if (exerciseId) {
      const payload = (
        await axios.post(
          `/exercises/${exerciseId}/review_exercises_by_students.json`,
          {
            user_ids: window.sessionStorage.getItem('userid').split(','),
          }
        )
      ).data;
      dispatch({ type: "init", payload });
      return true;
    }
  }, [exerciseId]);

  if (!isLoaded) {
    return <Spin spinning={true} size="large" style={{width:'100%',height:'80%',position:'fixed',display:'flex',alignItems:'center',textAlign:'center',justifyContent:'center'}}></Spin>;
  }
  
  return (
    <Spin
      spinning={isloading}
      size="large" 
      style={{width:'100%',marginTop:'200px',height:'80%',position:'fixed',display:'flex',alignItems:'center',textAlign:'center',justifyContent:'center'}}
    >
    <Background>
      <Nav {...{ current_user, reviewData }} />
      <Paper>
        <UpdateCtx.Provider value={dispatch}>
          <Head reviewData={reviewData} />
          <Content reviewData={reviewData} />
        </UpdateCtx.Provider>
      </Paper>
    </Background>
    </Spin>

  );
};

export default (props) => {
  return (
    <HooksMocker {...props}>
      {props.current_user && <Inner current_user={props.current_user} />}
    </HooksMocker>
  );
};
