import React from "react";
import styled from "styled-components";
import { Typo, Popover } from "../util/widget";
import { FlexBox, BetweenBox, Margin } from "../util/layout";
import { Tooltip } from "antd";

const { Text } = Typo;

const Container = styled.div`
  padding: 16px 24px;
  border-bottom: 1px solid rgba(0, 0, 0, 0.06);
`;
const Name = styled(Text)`
  margin-right: 14px;
  margin-top: 8px;
  font-weight: 500;
  color: black;
`;

export default ({ exercise_users }) => {
  return (
    <Container>
      <Text>您正在对以下学生进行批量评阅：</Text>
      <style>{`.SSSSSSS .ant-tooltip-inner{border-radius:2px;} `}</style>
      <FlexBox style={{ flexWrap: "wrap" }}>
        {exercise_users &&
          exercise_users.slice(0, 100).map((u) => (
            <Tooltip
              overlayClassName="SSSSSSS"
              title={`客观题得分 ${u.objective_score} 分`}
              placement="bottom"
            >
              <Name>{u.user_name}</Name>
            </Tooltip>
          ))}
      </FlexBox>
      <BetweenBox>
        <Margin h="50px"/>
        {exercise_users && exercise_users.length > 100 && (
          <div>......等{exercise_users.length}人</div>
        )}
      </BetweenBox>
    </Container>
  );
};
