import React from "react";
import styled from "styled-components";
import { BetweenBox, FlexBox } from "../util/layout";
import { Btn, Typo } from "../util/widget";
import { useHistory, useParams } from "../util/hooks";

const { ExitBtn, PrimaryBtn } = Btn;
const { Text } = Typo;

const Container = styled(BetweenBox)`
  position: sticky;
  height: 100px;
  bottom: 0;
`;

export default ({ users }) => {
  const history = useHistory();
  let { coursesId, Id: exerciseId, idx } = useParams();
  idx = Number(idx);
  const len = users.length;
  return (
    <Container>
      <ExitBtn style={{ marginLeft: "24px" }} onClick={()=>{
        history.push(`/classrooms/${coursesId}/exercises/${exerciseId}/student_exercise_list?tab=0`)
      }}>退出评阅</ExitBtn>
      <div style={{ marginRight: "24px" }}>
        {idx < len - 1 ? (
          <FlexBox>
            <Text>下一个可评学生：</Text>
            <PrimaryBtn
              style={{padding:"5px 16px"}}
              onClick={() => {
                history.push({
                  pathname: `/classrooms/${coursesId}/exercises/${exerciseId}/order/${
                    idx + 1
                  }`,
                  state: users,
                });
              }}
            >
              {users[idx + 1].user_name}
            </PrimaryBtn>
          </FlexBox>
        ) : (
          <Text>当前已是最后一位需要评阅的学生，为您点赞！</Text>
        )}
      </div>
    </Container>
  );
};
