import React from "react";
import { questionName } from "../util";
import { BetweenBox, FlexBox, Margin } from "../../util/layout";
import RenderHtml from "../../../../../components/render-html";
import { AnsSheet } from "../style";
import { Con } from "../style";
import {
  GAdjust,
  QuesIdx,
  Score,
  useGAdjust,
  SAdjust,
  useAdjust,
  Comm,
  EdComm,
  StandAns,
} from "./util";

//可调分
export default ({ question, is_md, exercise_answer_user, isGroup = false }) => {
  const question_name = questionName(question);
  let Adjust, adj;
  if (isGroup) {
    Adjust = GAdjust;
    adj = useGAdjust(question);
  } else {
    Adjust = SAdjust;
    adj = useAdjust(question, exercise_answer_user);
  }
  return (
    <Con>
      <BetweenBox>
        <QuesIdx question={question} />
        <FlexBox>
          <Adjust
            inputVisible={adj.vis}
            question={question}
            adjustScore={adj.adjustScore}
            setVis={adj.setV}
          />
          <Score question={question} isGroup={isGroup} />
        </FlexBox>
      </BetweenBox>
      <Margin h="12px" />
      <RenderHtml value={question_name} is_md={is_md} />
      <Margin h="12px" />
      {question.user_answer.map((a) => (
        <FlexBox style={{ marginBottom: "10px" }}>
          <div>填空{a.choice_id}</div>
          <Margin w="10px" />
          <AnsSheet>
            <RenderHtml value={a.answer_text} is_md={is_md} />
          </AnsSheet>
        </FlexBox>
      ))}
      <Margin h="5px" />
      <StandAns>
        <Margin h="5px" />
        {question.standard_answer.map((a) => (
          <FlexBox style={{ marginBottom: "10px" }}>
            <div>填空{a.choice_id}</div>
            <Margin w="10px" />
            <AnsSheet>
              <RenderHtml value={a.answer_text[0]} is_md={is_md} />
            </AnsSheet>
          </FlexBox>
        ))}
      </StandAns>
      {!adj.vis &&
        question.question_comments &&
        question.question_comments.length != 0 && (
          <Comm question_comments={question.question_comments} />
        )}
      {adj.vis && <EdComm value={adj.comm} onChange={adj.setComm} />}
    </Con>
  );
};
