import React from "react";
import RenderHtml from "../../../../../components/render-html";
import Radio from "../../util/widget/Radio";
import { BetweenBox, FlexBox, Margin } from "../../util/layout";
import Score from "./util/Score";
import QIdxTpye from "./util/QuesIdx&Type";
import { tagArray, questionName } from "../util";
import { Con } from "../style";
import styled from "styled-components";

const RH = styled(RenderHtml)`
  &.markdown-body p {
    font-size: 14px !important;
  }
`;

const arr = ["正确", "错误"];

export default ({ question, is_md }) => {
  const question_name = questionName(question);
  return (
    <Con>
      <BetweenBox>
        <QIdxTpye question={question} />
        <FlexBox style={{ alignItems: "baseline" }}>
          正确答案：{arr[question.standard_answer[0] - 1]}
          <Margin w="10px" />
          <Score question={question} />
        </FlexBox>
      </BetweenBox>
      <Margin h="12px" />
      <RenderHtml value={question_name} is_md={is_md} />
      <Margin h="12px" />
      <div>
        {question.question_choices.map((choice, idx) => {
          const str = choice.choice_text;
          return (
            <Radio key={tagArray[idx]} value={choice.user_answer_boolean}>
              <span
                style={{
                  display: "inline-block",
                  position: "relative",
                  top: "-2px",
                }}
              >
                &nbsp;
                <RH
                  style={{
                    display: "inline-block",
                    position: "relative",
                    top: "7px",
                  }}
                  value={str}
                  is_md={is_md}
                />
              </span>
              <span
                style={{
                  display: "inline-block",
                  width: "20px",
                }}
              />
            </Radio>
          );
        })}
      </div>
    </Con>
  );
};
