import React from "react";
import RenderHtml from "../../../../../components/render-html";
import Check from "../../util/widget/Check";
import { BetweenBox, FlexBox, Margin } from "../../util/layout";
import { tagArray, questionName } from "../util";
import { QuesIdx, Score } from "./util";
import { Con } from "../style";
import styled from "styled-components";

const RH = styled(RenderHtml)`
  &.markdown-body p {
    font-size: 14px !important;
  }
`;

export default ({ question, is_md }) => {
  const question_name = questionName(question);
  return (
    <Con>
      <BetweenBox>
        <QuesIdx question={question} />
        <FlexBox style={{alignItems:"baseline"}}>
          正确答案：
          {question.standard_answer.map((idx) => tagArray[idx]).join("")}
          <Margin w="10px" />
          <Score question={question} />
        </FlexBox>
      </BetweenBox>
      <Margin h="12px" />
      <RenderHtml value={question_name} is_md={is_md} />
      <Margin h="12px" />
      {question.question_choices.map((choice, idx) => {
        const str = choice.choice_text;
        return (
          <Check key={idx} value={choice.user_answer_boolean}>
            <span
              style={{
                display: "inline-block",
                position: "relative",
                top: "-5px",
              }}
            >
              <span style={{color:"black"}}>{tagArray[idx]}.&nbsp;</span>
              <RH
                style={{
                  display: "inline-block",
                  position: "relative",
                  top: "7px",
                }}
                value={str}
                is_md={is_md}
              />
            </span>
          </Check>
        );
      })}
    </Con>
  );
};
