import React from "react";
import { questionName } from "../util";
import { BetweenBox, FlexBox, Margin } from "../../util/layout";
import RenderHtml from "../../../../../components/render-html";
import styled from "styled-components";
import { AnsSheet, Con } from "../style";
import {
  GAdjust,
  QuesIdx,
  Score,
  useGAdjust,
  SAdjust,
  useAdjust,
  Comm,
  EdComm,
  StandAns,
} from "./util";

const RH = styled(RenderHtml)`
  &.markdown-body p {
    font-size: 12px !important;
    position: relative;
    top: -3px;
  }
`;

//可调分
export default ({ question, is_md, exercise_answer_user, isGroup = false }) => {
  const question_name = questionName(question);
  let Adjust, adj;
  if (isGroup) {
    Adjust = GAdjust;
    adj = useGAdjust(question);
  } else {
    Adjust = SAdjust;
    adj = useAdjust(question, exercise_answer_user);
  }
  return (
    <Con>
      <BetweenBox>
        <QuesIdx question={question} />
        <FlexBox>
          <Adjust
            inputVisible={adj.vis}
            question={question}
            adjustScore={adj.adjustScore}
            setVis={adj.setV}
          />
          <Score question={question} isGroup={isGroup} />
        </FlexBox>
      </BetweenBox>
      <Margin h="12px" />
      <RenderHtml value={question_name} is_md={is_md} />
      <Margin h="16px" />
      {!isGroup && question.user_answer[0] && (
        <AnsSheet>
          <RenderHtml value={question.user_answer[0]} is_md={is_md} />
        </AnsSheet>
      )}
      <StandAns>
        <RH value={question.standard_answer[0]} is_md={is_md} />
      </StandAns>
      <Margin h="5px" />
      {!adj.vis &&
        question.question_comments &&
        question.question_comments.length != 0 && (
          <Comm question_comments={question.question_comments} />
        )}
      {adj.vis && <EdComm value={adj.comm} onChange={adj.setComm} />}
    </Con>
  );
};
