import React from "react";
import RenderHtml from "../../../../../../components/render-html";
import { questionName } from "../../util";
import SAdjust from "./ExecAdjust";
import GAdjust from "./ExecGAdjust";
import DetailItem from "./ExecDetailItem";
import { QuesIdx } from "../util";
import { Con } from "../../style";
import _ from "lodash";
import { Margin } from "../../../util/layout";

export default ({ question, is_md, exercise_answer_user, isGroup = false }) => {
  const question_name = questionName(question);
  let Adjust;
  if (isGroup) {
    Adjust = GAdjust;
  } else {
    Adjust = SAdjust;
  }
  return (
    <Con>
      <QuesIdx question={question} />
      <Margin h="12px"/>
      <RenderHtml value={question_name} is_md={is_md} />
      <Margin h="12px"/>
      <div>阶段成绩</div>
      <Margin h="12px"/>
      <Adjust {...{ question, exercise_answer_user, isGroup }} />
      {!isGroup &&
        _.some(
          question.shixun_details.map((d) => Boolean(d.shixun_detail))
        ) && <div style={{margin:"12px 0"}}>实训详情</div>}
      {!isGroup &&
        question.shixun_details.map((d) => {
          if (d.shixun_detail) {
            return (
              <DetailItem
                item={d.shixun_detail[0]}
                q_position={question.q_position}
              />
            );
          }
        })}
    </Con>
  );
};
