import React from "react";
import RenderHtml from "../../../../../../components/render-html";
import {
  GAdjust,
  QuesIdx,
  Score,
  useGAdjust,
  SAdjust,
  useAdjust,
} from "../util";
import { BetweenBox, FlexBox, Margin } from "../../../util/layout";
import { Con } from "../../style";
import { ProgDetail } from "./ExecDetailItem";


export default ({ question, is_md, exercise_answer_user, isGroup = false }) => {
  const question_description = question.description;
  let Adjust, adj;
  if (isGroup) {
    Adjust = GAdjust;
    adj = useGAdjust(question);
  } else {
    Adjust = SAdjust;
    adj = useAdjust(question, exercise_answer_user);
  }
  return (
    <Con>
      <BetweenBox>
        <QuesIdx question={question} />
        <FlexBox>
          <Adjust
            inputVisible={adj.vis}
            question={question}
            adjustScore={adj.adjustScore}
            setVis={adj.setV}
          />
          <Score question={question} isGroup={isGroup} />
        </FlexBox>
      </BetweenBox>
      <Margin h="12px" />
      <RenderHtml value={question_description} is_md={is_md} />
      <Margin h="12px" />
      <ProgDetail
        evaluate_codes={question.evaluate_codes}
        user_answer={question.user_answer && question.user_answer[0]}
      />
    </Con>
  );
};
