import React from "react";
import { ScoreDesc } from "../../style";
import { isSubQ, isSubQReviewed } from "../../util";

export default ({ question, isGroup = false }) => {
  if (isGroup) {
    if (question.reviewed) {
      return <ScoreDesc c="#2ABD8C">已评</ScoreDesc>;
    } else {
      return <ScoreDesc c="#FB3226">未评</ScoreDesc>;
    }
  }
  if (isSubQ(question) && !isSubQReviewed(question)) {
    return <ScoreDesc c="#FB3226">未评</ScoreDesc>;
  }
  if(question.user_score===null){
    return <ScoreDesc c="#FB3226">未评</ScoreDesc>;
  }
  return (
    <ScoreDesc>
      得分&nbsp;
      <span style={{color:!isSubQ(question)&&Number(question.user_score)&&"#2ABD8C"}}>{question.user_score}</span>
      &nbsp; 分
    </ScoreDesc>
  );
};
