import React, { useState, useCallback, useContext } from "react";
import { FlexBox, Margin } from "../../../../util/layout";
import { Input, Popover, Btn } from "../../../../util/widget";
import classnames from "classnames";
import { isSubQReviewed } from "../../../util";
import { Tooltip } from "antd";
const { TextBtn, PrimaryBtn } = Btn;

export default ({ question, inputVisible, adjustScore, setVis }) => {
  const [v, setV] = useState(undefined);
  const [tip, setTip] = useState("");
  const changeScore = useCallback(
    (v) => {
      setV(v);
      const reg = /^[0-9]+(\.[0-9])?$/;
      if (reg.test(v) == false) {
        setTip("请输入正数");
        return;
      }
      const num = Number(v);
      if (num > question.question_score) {
        setTip("分数不能大于当前题目的分数");
        return;
      }
      setTip("");
    },
    [question.question_score]
  );

  return (
    <FlexBox>
      {!inputVisible && <TextBtn onClick={setVis}>调分</TextBtn>}
      {inputVisible && (
        <FlexBox>
          调分<Margin w="8px"/>
          <Tooltip placement="top" title={tip} visible={Boolean(tip)}>
            <Input
              style={{ width: "42px",height:"24px" }}
              placeholder="0.0"
              value={v}
              onChange={changeScore}
              className={classnames({ "has-error": Boolean(tip) })}
            />
          </Tooltip>
          <Margin w="8px"/>
          分<Margin w="8px"/>
          <PrimaryBtn
            disable={Boolean(tip) || !Boolean(v)}
            onClick={() => {
              adjustScore(v);
            }}
          >
            确认
          </PrimaryBtn>
          
        </FlexBox>
      )}
      <Margin w="8px"/>
    </FlexBox>
  );
};
