import React from "react";
import styled from "styled-components";
import { getImageUrl } from "educoder";
import { Typo } from "../../../../util/widget";
import moment from "moment";
import { Margin } from "../../../../util/layout";

const { Text } = Typo;

const Comment = styled(Text)`
  background: rgba(250, 250, 250, 1);
  font-weight:500;
  border-radius:2px;
  width: 100%;
  height: 132px;
  padding: 16px 16px;
  color: #666666;
`;

const Container = styled.div`
  margin-top:8px;
  display: flex;
  align-items: flex-start;
  border-top: 1px solid rgba(0, 0, 0, 0.06);
  padding-top: 20px;
  img {
    width: 38px;
    height: 38px;
    border-radius: 50%;
    display: block;
  }
`;

// (item.question_type == 3 ||  item.question_type == 4 ||  item.question_type == 1)
export default ({ question_comments }) => {
  return (
    <Container>
      <img
        src={getImageUrl(`images/${question_comments.user_picture}`)}
        alt="avatar"
      />
      <Margin w="10px" />
      <div style={{ flex: "1" ,width:'0'}}>
        <Text color=" #999999" weight="300">
          {moment(question_comments.updated_at).format("YYYY-MM-DD HH:mm")}
        </Text>
        <Text weight="500">{question_comments.user_name}</Text>
        <Margin h="10px" />
        <Comment>{question_comments.comment}</Comment>
      </div>
    </Container>
  );
};
