import styled from "styled-components";
import { BetweenBox, FlexBox } from "../util/layout";
import { FontMixinGen } from "../util/cssMixin";
export const Row = styled.div`
  padding: 16px 24px;
  border-bottom: 1px solid rgba(0, 0, 0, 0.06);
`;
export const Row2 = styled.div`
  padding: 16px 0;
  margin: 0 24px;
  border-bottom: 1px solid rgba(0, 0, 0, 0.06);
`
export const Con = styled.div`
  padding: 16px 0;
  &:not(:last-child) {
    border-bottom: 1px solid rgba(0, 0, 0, 0.06);
  }
`;

export const Tiaofen = styled.div`
  ${FontMixinGen(14)}
  font-weight:500;
  color: #1890ff;
  :hover {
    cursor: pointer;
  }
`;
export const Weiping = styled.div`
  ${FontMixinGen(14)}
  font-weight:500;
  color: #fb3226;
`;

export const QTitle = styled.div`
  ${FontMixinGen(14)}
  color: #1890FF;
  font-weight: 500;
  span {
    color: #666666;
  }
`;

export const ScoreDesc = styled.div`
  ${FontMixinGen(14)}
  font-weight:500;
  color: ${(p) => p.c};
  & > span {
    color: #fb3226;
  }
`;
export const QtypeScoreDesc = styled.div`
  ${FontMixinGen(12)}
  color:#FD8001;
  margin-right: 13px;
`;
export const StuDesc = styled.div`
  ${FontMixinGen(14)}
  & span {
    display: inline-block;
    margin-left: 8px;
    color: rgba(102, 102, 102, 1);
  }
  margin-right: 24px;
  color:black;
`;

export const Container = styled.div`
  padding: 14px 24px;
  border-bottom: 1px solid rgba(0, 0, 0, 0.06);
`;
export const Show = styled(FlexBox)`
  ${FontMixinGen(12)}
  align-items:center;
  color: ${(p) => p.color};
  vertical-align: middle;
  &::before {
    content: "";
    width: 12px;
    height: 12px;
    border-radius: 50%;
    display: inline-block;
    margin-right: 4px;
    margin-left: 16px;
    background: ${(p) => p.color};
  }
`;
export const QType = styled.span`
  ${FontMixinGen(14)}
  font-weight:500;
`;

export const AnsSheet = styled.div`
  min-height:50;
  padding:12px 12px;
  ${FontMixinGen(16)}
  flex:1;
  color: rgba(17, 17, 17, 1);
  background: rgba(255, 255, 255, 1);
  border-radius: 2px;
  border: 1px solid rgba(249, 249, 249, 1);
  font-weight:300;
  letter-spacing:1px;
`;
