import React, { Component } from "react";
import { Radio } from 'antd';
import QestionDisplayHeader from './QestionDisplayHeader'
import RenderHtml from "../../../../components/render-html";


class JudgeDisplay extends Component {
  render() {
    let { question_choices, question_id, index, is_md } = this.props;
    const qNumber = `question_${index}`;

    return (
      <div className="bor-bottom-greyE padding20-30" id={qNumber} _id={question_id}>
        <style>{`
              .optionMdEditor {
                flex: 0 0 800px
              }
              .optionRow {
                margin: 2px;
              }
              .actionBtns {
                  height: 28px
              }
              
            `}</style>

        <QestionDisplayHeader {...this.props}></QestionDisplayHeader>
        <div className="options clearfix">
          {question_choices.map((item, optionIndex) => {
            return (
              <div key={optionIndex} className="fl mr30 df">
                <Radio disabled className="lineh-25" checked={item.standard_boolean}></Radio>
                <RenderHtml value={item.choice_text} is_md={is_md} />
              </div>)

          })}

        </div>
      </div>
    )
  }
}
// RouteHOC()
export default (JudgeDisplay);