import React, { Component } from "react";
import { Tooltip, Input } from 'antd';

const { TextArea } = Input

class NullChildEditor extends Component {

  render() {
    let { index, onAnswerChange, addChildAnswer, exerciseIsPublish, answers, activeOptionErrorIndex } = this.props;
    return (
      <div className="df" >
        <div className="color-grey-6 mb5 mt6" style={{ flex: '0 0 90px' }}>答案(填空{index + 1}):</div>
        <div className="df flex1" style={{ flexDirection: 'column' }}>
          {
            answers.map((item, itemIndex) => {
              let cid = `${index}-${itemIndex}`
              return <div className="df flex1" key={itemIndex} >
                <div className="flex1" style={{ flex: '0 0 1000px' }}>
                  <div className={cid === activeOptionErrorIndex ? 'text-area-editor error' : 'text-area-editor'}>
                    <TextArea rows={4} value={item || ''} defaultValue={`请输入参考答案${itemIndex == 0 ? '' : '(可选)'}`} onChange={
                      event => onAnswerChange(index, itemIndex, event.target.value)
                    } style={{minHeight:95}}/>
                  </div>
                </div>
                {!exerciseIsPublish &&
                  <React.Fragment>
                    {itemIndex != 0 && <Tooltip title="删除">
                      <i className="iconfont icon-htmal5icon19 font-18 color-grey-c ml10"
                        onClick={() => this.props.deleteChildAnswer(index, itemIndex)}
                        style={{ float: 'right' }}
                      ></i>
                    </Tooltip>}
                    {itemIndex === 0 && <Tooltip title="删除">
                      <i className="iconfont icon-htmal5icon19 font-18 color-grey-c ml10"
                        onClick={() => this.props.deleteChildAnswermain(index, itemIndex)}
                        style={{ float: 'right' }}
                      ></i>
                    </Tooltip>}
                    {<Tooltip title={`新增参考答案`}>
                      <i className="color-green font-16 iconfont icon-roundaddfill ml6"
                        onClick={() => addChildAnswer(index)}
                        style={{ float: 'right', visibility: itemIndex == answers.length - 1 ? '' : 'hidden', marginTop: '2px' }}
                      ></i>
                    </Tooltip>}
                  </React.Fragment>
                }
              </div>
            })
          }
        </div>
      </div>
    )
  }
}
export default NullChildEditor;