import React, {Component} from 'react'
import TPMMDEditor from '../../../tpm/challengesnew/tpm-md-editor'
const NULL_CH = '▁'

export default class NullMDEditor extends Component {
    getChCountBeforeCursor = (cm, cursor) => {
        const currentLine = cursor.line;
        let placeholderCountBefore = 0
        for(let _line = 0; _line < currentLine; _line++) {
            placeholderCountBefore += cm.getLine(_line).split(NULL_CH).length - 1;
        }
        const currentLineStringBeforeCursor = cm.getLine(currentLine).substring(0, cursor.ch)
        placeholderCountBefore += currentLineStringBeforeCursor.split(NULL_CH).length - 1;
        return placeholderCountBefore;
    }
    onCMBeforeChange = (cm, change) => {
        
        const rangeText = cm.getRange(change.from, change.to)
        let totalPlaceholderCount = 0 
        change.text.forEach(item => {
          totalPlaceholderCount += item.split(NULL_CH).length - 1
        })

        if (rangeText && rangeText.indexOf(NULL_CH) != -1) {
            const placeholderCountInRange = rangeText.split(NULL_CH).length - 1;
            const placeholderCountBefore = this.getChCountBeforeCursor(cm, change.from)
            console.log(`删除${placeholderCountInRange}个， 之前有${placeholderCountBefore}个，新增${totalPlaceholderCount}个`)

            const ret = window.confirm(`确认要删除第${placeholderCountInRange == 1 ? placeholderCountBefore + 1 
                : `${placeholderCountBefore + 1}-${placeholderCountBefore + placeholderCountInRange}` }个空吗？`)
            if (ret) {
                this.props.onPlaceholderChange
                    && this.props.onPlaceholderChange(placeholderCountBefore, placeholderCountInRange, totalPlaceholderCount)
            } else {
                change.cancel()
            }

        } else if (totalPlaceholderCount) {
            const placeholderCountBefore = this.getChCountBeforeCursor(cm, change.from)

            console.log(`新增${totalPlaceholderCount}个，之前有${placeholderCountBefore}个`)
            this.props.onPlaceholderChange 
                && this.props.onPlaceholderChange(placeholderCountBefore, 0, totalPlaceholderCount)

        }
        
    }

    render() {

        return (
            <TPMMDEditor {...this.props}
                onCMBeforeChange={this.onCMBeforeChange}
            >    
            </TPMMDEditor>
        )
    }
}