import React, { Component } from "react";
import { Tooltip } from 'antd';
import { qNameArray } from './common'
import RenderHtml from "../../../../components/render-html";

class QestionDisplayHeader extends Component {

    render() {
        let { question_title, question_score, question_type,
            question_id, index, displayCount, is_md,
            topRight, showActionButton, exerciseIsPublish
        } = this.props;

        const qName = qNameArray[question_type]

        return (
            <React.Fragment>
                <div className="new_li">
                    <style>{`
            .actionBtns {
                height: 28px
            }
            `}</style>
                    <div className="font-16 fl">
                        <span className="color-blue">{index + 1}、{qName}</span>
                        <span className="color-grey-9">（{question_score}分）</span>
                    </div>
                    <div className="fr actionBtns">
                        {topRight}
                        {showActionButton != false && <React.Fragment>
                            {!exerciseIsPublish && <a className="mr30" onClick={() => this.props.onQestionDelete(question_id)}>
                                <Tooltip title="删除">
                                    <i className="color-grey-cd font-16 iconfont icon-shanchu"></i>
                                </Tooltip>
                            </a>}
                            {index === 0 ? "" :
                                <a className="mr30" onClick={() => this.props.onSortUp(index, question_id)}>
                                    <Tooltip title="上移">
                                        <i className="color-green font-18 iconfont icon-xiangshangyi"></i>
                                    </Tooltip>
                                </a>}
                            {index === displayCount - 1 ? "" :
                                <a className="mr30" onClick={() => this.props.onSortDown(index, question_id)}>
                                    <Tooltip title="下移">
                                        <i className="color-green font-18 iconfont icon-xiangxiayi"></i>
                                    </Tooltip>
                                </a>}
                            {!exerciseIsPublish && this.props.question_type != 6 && <a className="mr30" onClick={() => this.props.addQuestion(question_id, question_type)}>
                                <Tooltip title={`(向下插入${qName})`}>
                                    <i className="color-green font-18 iconfont icon-roundaddfill"></i>
                                </Tooltip>
                            </a>}
                            <a onClick={() => this.props.editQestion(index, this.props)}>
                                <Tooltip title="编辑"><i className="color-green font-18 iconfont icon-bianjidaibeijing"></i></Tooltip>
                            </a>
                        </React.Fragment>}
                    </div>
                </div>

                {question_title ? <RenderHtml is_md={is_md} className='question-title-container' value={question_title} /> : null}

            </React.Fragment>
        )
    }
}
// RouteHOC()
export default (QestionDisplayHeader);