import React, { Component } from "react";
import QestionDisplayHeader from './QestionDisplayHeader'
import RenderHtml from "../../../../components/render-html";

class ShixunDisplay extends Component {

    render() {
        let { question_title,
            question_id, index,

            shixun_name, shixun, shixun_identifier, is_md
        } = this.props;

        const qNumber = `question_${index}`;

        /**
        {                    #实训题
                "question_id": 7294,
                "question_number": 3,
                "question_title": "独立完成数据库知识",
                "question_type": 5,
                "exercise_id": 763,
                "question_score": 35,
                "shixun_id": 41,
                "shixun_name": "MySQL数据库编程开发实训（基础篇）",
                "shixun": [
                    {
                        "challenge_id": 69,
                        "challenge_position": 1,
                        "challenge_name": "数据库连接与数据库实例创建",
                        "challenge_score": 5
                    },
                    {
                        "challenge_id": 70,
                        "challenge_position": 2,
                        "challenge_name": "数据表的创建",
                        "challenge_score": 5
                    },
                    {
                        "challenge_id": 71,
                        "challenge_position": 3,
                        "challenge_name": "数据查询操作",
                        "challenge_score": 5
                    },
                    {
                        "challenge_id": 72,
                        "challenge_position": 4,
                        "challenge_name": "数据库的插入操作",
                        "challenge_score": 5
                    },
                    {
                        "challenge_id": 73,
                        "challenge_position": 5,
                        "challenge_name": "数据表的删除操作",
                        "challenge_score": 5
                    },
                    {
                        "challenge_id": 74,
                        "challenge_position": 6,
                        "challenge_name": "数据表的更新操作",
                        "challenge_score": 5
                    },
                    {
                        "challenge_id": 75,
                        "challenge_position": 7,
                        "challenge_name": "数据库的应用",
                        "challenge_score": 5
                    }
                ]
            }
         */
        // let length = 5;
        // const qName = qNameArray[question_type]
        return (
            <div className="bor-bottom-greyE padding20-30" id={qNumber} _id={question_id}>
                <style>{`

              .mainQuestionDisplay {
                margin-bottom:15px;
              }
              
            `}</style>

                <QestionDisplayHeader {...this.props} question_title={shixun_name}
                    topRight={
                        <a target="_blank" href={`/shixuns/${shixun_identifier}/challenges`} className="mr30"
                            style={{ color: '#4CACFF' }}
                        >实训详情</a>
                    }
                ></QestionDisplayHeader>


                <RenderHtml className="mainQuestionDisplay color-grey-9 markdown-body" is_md={is_md} value={question_title} />

                {shixun.map((ch, index) => {
                    return <div>
                        {`第${index + 1}关`}　{ch.challenge_name}　{ch.challenge_score}分
                </div>
                })}

            </div>
        )
    }
}
// RouteHOC()
export default (ShixunDisplay);