import React, { Component } from "react";
import { InputNumber } from 'antd'
import { ActionBtn } from 'educoder';
import QestionDisplayHeader from './QestionDisplayHeader'
import axios from 'axios'
import RenderHtml from "../../../../components/render-html";

class ShixunProgramming extends Component {
  constructor(props) {
    super(props);
    this.state = {
      question_scores: null,
      edits: false
    }
  }

  on_question_score_change = (e, index) => {
    const value = e
    this.setState({ question_scores: value, edits: true })
  }
  onSave = () => {
    const { question_scores, edits } = this.state;
    const { index, question_id, question_score, is_md } = this.props
    if (edits) {
      if (!question_scores || question_scores == '0') {
        this.props.showNotification(`第${index + 1}道编程题调整的分值：必须大于0`);
        return
      }
    } else {
      if (!question_score || question_score == '0') {
        this.props.showNotification(`第${index + 1}道编程题调整的分值：必须大于0`);
        return
      }
    }

    const url = `/exercise_questions/${question_id}/update_question_score.json`;

    axios.post(url, {
      question_score: question_scores ? question_scores : question_score
    })
      .then((response) => {
        if (response.data.status == 0) {
          this.props.showNotification(`调分成功`);
          this.props.addSuccess()
        }
      })
      .catch(function (error) {
        console.log(error);
      });

  }
  seturlsbc(id) {
		let url = `/problems/${id}/start.json`;
		axios.get(url, {}).then((response) => {
			if (response) {
				if (response.data.status === 0) {
					let newOpenWindow = window.open('about:blank');  // 在ajax外部先打开空白新窗口
					let identifiers = response.data.identifier;
					newOpenWindow.location = `/myproblems/${identifiers}?type=exercises`;
				} else {
					this.props.showNotification(response.data.message);
				}
			}
		});
	}
  render() {
    let { description, question_title, exerciseIsPublish,
      question_id, index, is_md, question_score,exercise_status,hack_identifier
    } = this.props;
    let { question_scores } = this.state;
    const isAdmin = this.props.isAdmin()
    const qNumber = `question_${index}`

    return (
      <div className="bor-bottom-greyE padding20-30" id={qNumber} _id={question_id}>
        <style>{`

              .mainQuestionDisplay {
                margin-bottom:15px;
              }
              
            `}</style>

        <QestionDisplayHeader {...this.props} question_title={question_title}
          topRight={
            <a onClick={() => this.seturlsbc(hack_identifier)} className="mr30"
                style={{ color: '#4CACFF' }}
            >查看详情</a>
        }   
        ></QestionDisplayHeader>

        {description && <RenderHtml value={description} is_md={is_md} />}
        {exerciseIsPublish && isAdmin && <div className={"mt20"}>
          分值：
          <InputNumber step={0.1} precision={1} min={0} max={100} style={{ width: 100 }}
            value={question_scores ? question_scores : question_score}
            onChange={this.on_question_score_change}
            disabled={exercise_status===1===false}
          ></InputNumber>&nbsp;分

          {exercise_status === 1 ? <span className="fr">
            <ActionBtn style="blue" className="middle"
              onClick={this.onSave}
            >保存</ActionBtn>
          </span> : ""}

        </div>}
      </div>
    )
  }
}
export default ShixunProgramming;
