import React, { Component } from "react";
import { Radio, Checkbox } from 'antd';
import QestionDisplayHeader from './QestionDisplayHeader'
import RenderHtml from "../../../../components/render-html";

const tagArray = [
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
  'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
  'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
]
class SingleDisplay extends Component {

  render() {
    let { question_type, question_choices,
      question_id, index, is_md
    } = this.props;


    const qNumber = `question_${index}`;

    return (
      <div className="bor-bottom-greyE padding20-30 singleDisplay" id={qNumber} _id={question_id}>
        <style>{`
              .optionMdEditor {
                flex: 0 0 800px
              }
              .optionRow {
                margin: 2px;
              }
              .actionBtns {
                  height: 28px
              }
            `}</style>

        <QestionDisplayHeader {...this.props}></QestionDisplayHeader>

        {/* 单选 or 多选 */}
        <div className="options">
          {question_choices.map((item, optionIndex) => {
            let prefix = `${tagArray[optionIndex]}.`
            return (
              <div className="mb10 clearfix " style={{
                display: "flex",
                flexDirection: "row",
              }} key={optionIndex}>
                {question_type == 0 ? <Radio disabled className="fl lineh-25 w50" checked={item.standard_boolean}>{prefix}</Radio> : <Checkbox disabled className="fl lineh-25  w50" checked={item.standard_boolean}>{prefix}</Checkbox>}
                <RenderHtml className="mt2" value={item.choice_text} is_md={is_md} />

              </div>)


          })}

        </div>
      </div>
    )
  }
}

export default (SingleDisplay);
