import React, { Component } from "react";
import { Base64 } from 'js-base64';
import { UnControlled as CodeMirror } from 'react-codemirror2';
import ShixunProgrDetail from './ShixunProgrDetail'

class ShowProgramming extends Component {
  constructor(props) {
    super(props);
    this.state = {
      scoreList: [],
      data: [],
      challenge: [],
      dataCopy: []
    }
  }

  componentDidUpdate = (prevState) => {
    if (this.props.questionType && !prevState.questionType && prevState.questionType != this.props.questionType) {
      this.showInfo();
    }
  }

  componentDidMount = () => {
    this.showInfo();
  }

  showInfo = () => {
    let data = [];

    let challenge = [];
    let details = this.props.questionType.shixun_details;
    if (details) {
      for (var i = 0; i < details.length; i++) {
        for (var j = 0; j < details[i].stage_list.length; j++) {
          data.push({
            part: details[i].stage_list[j].position,
            shixunName: details[i].stage_list[j].name,
            testCount: details[i].stage_list[j].evaluate_count,
            endTime: details[i].stage_list[j].finished_time,
            needTime: details[i].stage_list[j].time_consuming,
            my_exp: details[i].stage_list[j].myself_experience,
            total_exp: details[i].stage_list[j].experience,
            my_score: details[i].stage_list[j].user_score,
            total_score: details[i].stage_list[j].game_score,
            input_score: details[i].stage_list[j].user_score,
            operation: details[i].shixun_detail && details[i].shixun_detail[0].game_identifier,
            id: details[i].shixun_challenge_id
          })
        }
        if (details[i].shixun_detail) {
          challenge.push(details[i].shixun_detail);
        }
      }
    }
    this.setState({
      data: data,
      dataCopy: data,
      challenge: challenge
    })
    // console.log(challenge);
  }


  render() {
    let { questionType } = this.props

    return (
      <div>
        <style>
          {`
            .resetTableStyle .ant-table-tbody > tr > td{
              padding:10px 5px!important;
            }
            .resetCodeMirrorStyle .CodeMirror{
              height:auto!important;
            }
          `}
        </style>

        <div>
          <div>

            <div className="pl15 pr15">

              <ShixunProgrDetail
                {...this.props}
                {...this.state}
              ></ShixunProgrDetail>

              {questionType.user_answer.length > 0 ? <div className="font-16 color-dark-21">
                <div className="bor-grey-e mt15">
                  <p className="clearfix pt5 pb5 pl15 pr15 back-f6-grey codebox">
                    <span className="fl">最近通过的代码</span>
                    {/*<span className="fr codeboxright">{item[0].path}</span>*/}
                  </p>

                  <div className="test-code bor-top-greyE">
                    <li className="clearfix resetCodeMirrorStyle">
                      <CodeMirror
                        value={questionType.user_answer[0] ? Base64.decode(questionType.user_answer[0]) : ""}
                        options={{
                          // mode: 'xml',
                          theme: 'default',
                          lineNumbers: true,
                          // extraKeys: {"Ctrl-Q": "autocomplete"}, // 快捷键
                          indentUnit: 4, //代码缩进为一个tab的距离
                          matchBrackets: true,
                          autoRefresh: true,
                          smartIndent: true,//智能换行
                          styleActiveLine: true,
                          lint: true,
                          readOnly: "nocursor"
                        }}
                      />
                    </li>
                  </div>
                </div>
              </div> : ""}
            </div>

          </div>

        </div>


      </div>
    )
  }
}
export default ShowProgramming