import React, { Component } from "react";
import { Input } from "antd";
import axios from 'axios'
const { TextArea } = Input

class fillEmpty extends Component {
  constructor(props) {
    super(props);
    let { questionType } = this.props;
    let array = [];
    for (var i = 0; i < questionType.multi_count; i++) {
      let item = "";
      if (questionType.user_answer.length > 0) {
        if (questionType.user_answer[i]) {
          item = questionType.user_answer[i].answer_text;
        }
      }
      array.push({
        value: item,
        q_id: questionType.question_number
      })
    }
    this.state = {
      array
    }
  }

  onOptionContentChange = (value, index) => {
    let array = this.state.array.slice(0);
    array[index].value = value;
    this.setState({ array })
  }

  onBlurEmpty = (index, number, event) => {
    let { questionType, changeQuestionStatus } = this.props
    let array = this.state.array.slice(0);
    let v = event.target.value;
    let question_id = questionType.question_id;
    let url = `/exercise_questions/${question_id}/exercise_answers.json`
    axios.post((url), {
      exercise_choice_id: parseInt(index) + 1,
      answer_text: v
    }).then((result) => {
      if (result.status == 200) {
        let count = 0;
        for (var i = 0; i < array.length; i++) {
          if (array[i].value == "") { count++; }
        }
        let k = count == array.length ? 0 : 1;
        changeQuestionStatus && changeQuestionStatus(parseInt(questionType.q_position) - 1, k);
      }
    }).catch((error) => {
      console.log(error);
    })
  }

  render() {
    let {
      questionType,
      user_exercise_status,
    } = this.props
    let {
      array
    } = this.state

    return (
      <div className="pl30 pr30">
        <style>{`
          .emptyPanel div#content_editorMd_show{
            width: 100%;
            border-radius: 4px;
            // height: 35px;
            margin-top:0px;
            background-color:#fafafa;
            color:#999;
            // line-height:25px;
          }
          .answerStyle{
            background:#f5f5f5;
            border-radius:4px;
            border: 1px solid #eaeaea;
            padding:5px;
            min-height:35px;
            box-sizing:border-box;
          }
          .pd10{
           padding: 10px;
          }
          .min40{
           min-height:40px;
          }
        `}</style>
        {
          array.map((item, key) => {
            return (
              <li className="df mb10 emptyPanel">
                <span className="mr10 lineh-35 font-16">答案（填空{key + 1}）:</span>
                {
                  user_exercise_status == 1 ? <div className="flex1  lineh-40 new_li">
                    <p key={key}
                      style={{ backgroundColor: "#F5F5F5" }}
                      className="new_li  answers lineh-40 pd10 min40 newcontent_editorMd_show" >
                      {item.value}
                    </p>
                  </div>
                    :
                    <div className="flex1">
                      <div className='text-area-editor' >
                        <TextArea rows={4} value={item.value} defaultValue={`输入填空${key + 1}的答案`} onBlur={(event) => this.onBlurEmpty(key, questionType.q_position, event)} onChange={
                          event => this.onOptionContentChange(event.target.value, key)
                        } />
                      </div>
                    </div>
                }

              </li>
            )
          })
        }
        {
          // 答案公开，且试卷已经截止
          questionType.standard_answer &&
          <div>
            <p className="bor-top-greyE pt20 mt20 font-16 mb10">参考答案：</p>
            {questionType.standard_answer && questionType.standard_answer.map((item, k) => {
              return (
                <ul className="df font-16">
                  <span className="mr10">答案（填空{k + 1}）:</span>
                  <li className="flex1 answers lineh-40 new_li">
                    {
                      item.answer_text && item.answer_text.map((i, index) => {
                        return (
                          <p key={index}
                            style={{ backgroundColor: "#F5F5F5" }}
                            className="new_li  answers lineh-40 pd10 min40 newcontent_editorMd_show" >
                            {i}
                          </p>
                        )
                      })
                    }
                  </li>
                </ul>
              )
            })
            }
          </div>
        }

      </div>
    )
  }
}
export default fillEmpty