import React, { Component } from "react";
import { Checkbox } from "antd";

import axios from 'axios'
import RenderHtml from "../../../../components/render-html";
import '../yslexercisetable.css';
const tagArray = [
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
  'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
  'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
]
class Multiple extends Component {
  saveId = (value) => {
    let question_id = this.props.questionType.question_id;
    let url = `/exercise_questions/${question_id}/exercise_answers.json`;
    let { index } = this.props;
    axios.post((url), {
      exercise_choice_id: value
    }).then((result) => {
      if (result.status == 200) {
        let k = 0;
        if (value.length > 0) {
          k = 1;
        } else {
          k = 0;
        }
        this.props.changeOption && this.props.changeOption(index, value);
        this.props.changeQuestionStatus && this.props.changeQuestionStatus(parseInt(this.props.questionType.q_position) - 1, k);
      }
    }).catch((error) => {
      console.log(error);
    })
  }

  render() {
    let {
      questionType,
      exercise,
      user_exercise_status,
      is_md
    } = this.props
    let isStudent = this.props.isStudent();

    return (
      <div className="pl30 pr30 singleDisplay">
        <style>
          {
            `
						.multiple .ql-editor {
							overflow: unset !important;
						  padding:0px  !important;
							}
						.multiple .ql-editor p{
							line-height: 25px !important;
							}
						`
          }
        </style>
        <Checkbox.Group className="with100" disabled={user_exercise_status == 1 ? true : false} onChange={this.saveId} value={questionType.user_answer}>
          {
            questionType.question_choices && questionType.question_choices.map((item, key) => {
              let prefix = `${tagArray[key]}.`
              let titename = item.choice_text;

              return (
                <p className="clearfix mb15 df resetStyle">
                  <Checkbox className="lineh-15 df setRadioStyle multiple" value={item.choice_id}>
                    <span className="fl mr3 lineh-25">{prefix}</span>
                    <RenderHtml className="flex1 mt2" style={{ display: "inline-block" }} value={titename} is_md={is_md} />
                  </Checkbox>
                </p>
              )
            })
          }
        </Checkbox.Group>
        {
          // 答案公开，且试卷已经截止
          isStudent && exercise && exercise.answer_open == true && exercise.exercise_status == 3 &&
          <p className="bor-top-greyE pt20 mt10 font-16">参考答案：
            {questionType.standard_answer.map((i, k) => {
            return (
              <span value={k}>{tagArray[parseInt(i) - 1]}</span>
            )
          })
            }
          </p>
        }
      </div>
    )
  }
}
export default Multiple
