import React, { Component } from "react";
import { Radio } from "antd";
import axios from 'axios'
import RenderHtml from "../../../../components/render-html";
import '../yslexercisetable.css';
const tagArray = [
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
  'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
  'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
]
class single extends Component {

  changeItem = (e) => {
    let choiceId = e.target.value;
    let question_id = this.props.questionType.question_id;
    let { index } = this.props;
    let url = `/exercise_questions/${question_id}/exercise_answers.json`;
    axios.post((url), {
      exercise_choice_id: choiceId
    }).then((result) => {
      if (result) {
        this.props.changeOption && this.props.changeOption(index, [choiceId]);
        this.props.changeQuestionStatus && this.props.changeQuestionStatus(parseInt(this.props.questionType.q_position) - 1, 1);
      }
    }).catch((error) => {
      console.log(error);
    })
  }
  render() {
    let {
      questionType,
      exercise,
      user_exercise_status,
      is_md
    } = this.props

    let isStudent = this.props.isStudent();
    let isJudge = questionType.question_type == 2
    return (
      <div className="pl30 pr30 singleDisplay">
        <style>
          {
            `
						.single .ql-editor{
							overflow: unset !important;
							padding:0px  !important;
						}
						.single .ql-editor p{
							line-height: 25px !important;
							}
						.single {
						white-space: inherit !important;
						}	
							
						`
          }
        </style>
        <Radio.Group className="with100" disabled={user_exercise_status == 1 ? true : false} value={questionType.user_answer[0]} onChange={this.changeItem}>
          {
            questionType.question_choices && questionType.question_choices.map((item, key) => {
              let prefix = isJudge ? undefined : `${tagArray[key]}.`

              let titename = item.choice_text;
              return (
                <p key={item.choice_id} className={`resetStyle ${parseInt(questionType.question_type) == 0 ? "clearfix mb15" : "fl mr40"}`}>
                  <Radio className="df lineh-25 setRadioStyle single" value={item.choice_id}>
                    <span className="fl mr3 lineh-25">{prefix}</span>
                    <RenderHtml value={titename} className="flex1 mt2" style={{ display: "inline-block" }} />
                  </Radio>
                </p>
              )
            })
          }
        </Radio.Group>
        {
          // 答案公开，且试卷已经截止
          isStudent && exercise && exercise.answer_open == true && (exercise.exercise_status == 3 || user_exercise_status == 1) &&
          <p className="bor-top-greyE pt20 mt10 font-16">参考答案：
            {questionType.standard_answer.map((i, k) => {
            return (
              <span key={k} value={k}>{tagArray[parseInt(i) - 1]}</span>
            )
          })
            }
          </p>
        }
      </div>
    )
  }
}
export default single
