import styled from "styled-components";
import React, { forwardRef } from "react";
import classnames from "classnames";
import { FontMixinGen, AllCenterMixin, ExpandSizeMixin } from "../cssMixin";
import { FlexBox } from "../layout";
import { Check, UnCheck } from "./svg/check";
import { Icon } from ".";

const Container = styled(FlexBox)`
  ${FontMixinGen(12)}
  color: rgba(17, 17, 17, 1);
  :hover {
    cursor: pointer;
    & :not(.checked) {
      &.label {
        /* color: #1890ff; */
      }
    }
  }
  .label {
    margin-left: 4px;
  }
  .checkbox {
    width: 14px;
    height: 14px;
    position: relative;
  }
  input {
    visibility: hidden;
    position: absolute;
    ${ExpandSizeMixin}
  }
  .checked {
    &.label {
      color: #1890ff;
    }
  }
`;

export default ({ value, onChange, children }) => {
  return (
    <Container as="label">
      <div className="checkbox">
        <input
          type="checkbox"
          checked={value}
          onChange={() => {
            onChange && onChange(!value);
          }}
        />
        {value ? <Check /> : <UnCheck />}
      </div>
      <div className={classnames({ checked: value }, "label")}>{children}</div>
    </Container>
  );
};
