import styled from "styled-components";
import React from "react";
import { FlexBox } from "../layout";
import classnames from "classnames";

const Item = styled.div`
  padding: 8px 0;
  color:rgba(0,0,0,0.65);
  &:hover{
    cursor: pointer;
    color:#1890FF;
  }
  &.active{
    color:#1890FF;
    border-bottom:2px solid #1890FF;
  }
`;

export default styled(({className, itemArr, onChange, value }) => {
  return (
    <FlexBox className={className}>
      {itemArr.map((k) => (
        <Item
          className={classnames({active:value === k})}
          onClick={() => {
            onChange(k);
          }}
          key={k}
        >
          {k}
        </Item>
      ))}
    </FlexBox>
  );
})`
  &>div:not(:last-child){
    margin-right:30px;
  }
`;
