import React from "react";
import styled from "styled-components";

const toNum = (v) => {
  if (v === undefined) {
    return 0;
  }
  switch (v) {
    case "asc":
      return 2;
    case "desc":
      return 1;
  }
};
const toV = (n) => {
  if (n == 0) {
    return undefined;
  }
  if (n == 1) {
    return "desc";
  }
  return "asc";
};

const SVG = styled.svg.attrs(p=>({
  viewBox:"0 0 1024 1024",
  version:"1.1",
  xmlns:"http://www.w3.org/2000/svg",
}))`
  &:hover{
    cursor: pointer;
  }
  width:14px;
  height:14px;
`

export default ({ value, onChange }) => {
  return (
    <SVG
      onClick={() => {
        onChange(toV((toNum(value) + 1) % 3));
      }}
    >
      <path
        d="M709.060096 331.9808H315.024896c-11.8784 0-18.432-12.4928-11.1616-20.992L500.983296 82.5344a15.0528 15.0528 0 0 1 22.1184 0l197.12 228.4544c7.2704 8.4992 0.7168 20.992-11.1616 20.992z"
        fill={
          value === undefined
            ? "#999999"
            : value == "asc"
            ? "#999999"
            : "#000000"
        }
        p-id="14264"
      ></path>
      <path
        d="M709.060096 692.0192H315.024896c-11.8784 0-18.432 12.4928-11.1616 20.992l197.12 228.4544a15.0528 15.0528 0 0 0 22.1184 0l197.12-228.4544c7.2704-8.4992 0.7168-20.992-11.1616-20.992z"
        fill={
          value === undefined
            ? "#999999"
            : value == "asc"
            ? "#000000"
            : "#999999"
        }
        p-id="14263"
      ></path>
    </SVG>
  );
};
