import styled from "styled-components";
import React from "react";
import { Breadcrumb } from "antd";
import { FontMixinGen } from "../cssMixin";

const Box = styled.div`
  margin:10px 0;
  & .ant-breadcrumb{
    ${FontMixinGen(12)}
  }
  & .ant-breadcrumb-separator{
    margin:0 4px;
    position: relative;
    top:-1px;
  }
  & .ant-breadcrumb > span:last-child{
    color:black;
  }
`;

export default ({ items }) => (
  <Box>
    <Breadcrumb separator=">">
      {items.map((i) => (
        <Breadcrumb.Item>{i}</Breadcrumb.Item>
      ))}
    </Breadcrumb>
  </Box>
);
