import styled from "styled-components";
import React from "react";
import classnames from "classnames";

const Radio = ({ className, value, onChange, children }) => {
  return (
    <label className={className}>
      <span className="radio">
        <input
          type="radio"
          value={value}
          onChange={
            onChange || ((e) => {
              e.preventDefault();
            })
          }
        />
        <span className={classnames({ checked: value })} />
      </span>
      <span>{children}</span>
    </label>
  );
};

export default styled(Radio)`

  & :hover {
    cursor: pointer;
  }
  & .radio {
    width: 16px;
    height: 16px;
    display: inline-block;
    position: relative;
    > span {
      position: absolute;
      width: 100%;
      height: 100%;
      box-sizing: border-box;
      display: inline-block;
      border: 1px solid #999999;
      border-radius: 50%;
      display: flex;
      align-items: center;
      justify-content: center;
    }
  }
  & input {
    visibility: hidden;
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0px;
    left: 0px;
  }
  & .checked{
    border: 1px solid #2775ff;
    &::after {
      content: "";
      width: 60%;
      height: 60%;
      border-radius: 50%;
      background: #2775ff;
    }
  }
  & input + span:not(.checked):hover {
    border: 1px solid #1890ff;
  }
`;
