import styled from "styled-components";
import { AllCenterMixin, FontMixinGen } from "../cssMixin";
import React from "react";

const BaseTag = styled.div`
  height: 20px;
  min-width: 52px;
  border-radius: 10px;
  user-select: none;
  ${AllCenterMixin}
  ${FontMixinGen(12)}
  background:${(p) => p.background};
  border: ${(p) => `1px solid ${p.border}`};
  margin:0 2px;
  color: ${(p) => p.color || "#fff"};
`;

const mapData = [
  ["公开", ["#4CACFF"]],
  ["已开启补交", ["#028D01"]],
  ["未开启补交", ["#028D01"]],
  ["匿名作品", ["#006B75"]],
  ["已选择", ["#EDEDED"]],
  ["已结束", ["#EDEDED"]],
  ["提交中", ["#4CACFF"]],
  ["匿评中", ["#4CACFF"]],
  ["申诉中", ["#4CACFF"]],
  ["考试中", ["#F6FFED", "#B7EB8F", "#52C41A"]],
  ["补交中", ["#4CACFF"]],
  ["评阅中", ["#4CACFF"]],
  ["待选中", ["#4CACFF"]],
  ["已发布", ["#4CACFF"]],
  ["交叉评阅中", ["#4CACFF"]],
  ["已开启交叉评阅", ["#E99695"]],
  ["待确认", ["#5E5FB9"]],
  ["待处理", ["#5E5FB9"]],
  ["未发布", ["#84B6EB"]],
  ["私有", ["#84B6EB"]],
  ["未提交", ["#84B6EB"]],
  ["已确认", ["#FC2B6A"]],
  ["已截止", ["#FFF1F0", "#FFA39E", "#FB3226"]],
  ["开放课程", ["#FF6800"]],
];

const colorMap = new Map(mapData);

export default ({ type }) => {
  let [bk, bd = undefined, cl = undefined] = ["", "", ""];
  if (colorMap.has(type)) {
    [bk, bd = undefined, cl = undefined] = colorMap.get(type);
  }
  return (
    <BaseTag background={bk} border={bd} color={cl}>
      {type}
    </BaseTag>
  );
};
