import styled from "styled-components";
import React, { useCallback } from "react";
import { FontMixinGen } from "../cssMixin";

const T = ({ onChange, ...props }) => {
  const handle = useCallback(
    (e) => {
      onChange(e.target.value);
    },
    [onChange]
  );
  return <textarea {...props} onChange={handle} />;
};

export default styled(T)`
  ${FontMixinGen(14)}
  resize: none;
  background: rgba(250, 250, 250, 1);
  border-radius: 2px;
  padding: 12px 12px;
  border: 1px solid white;
  &:hover {
    border: 1px solid rgba(207, 207, 207, 1);
  }
  &::placeholder {
    color: #999999;
    font-weight:350;
  }
`;
