import styled from "styled-components";
import React, { useRef } from "react";
import { FontMixinGen } from "../cssMixin";
import { Tooltip as AdTooltip } from "antd";

const Tooltip = ({ className, children, ...props }) => {
  const ref = useRef(null);
  return (
    <AdTooltip
      className={className}
      {...props}
      getPopupContainer={() => ref.current}
    >
      <div ref={ref}>{children}</div>
    </AdTooltip>
  );
};

export default styled(Tooltip)`
  .ant-tooltip-content {
    ${FontMixinGen(14)}
  }
  .ant-tooltip-arrow .ant-tooltip-inner {
    background: rgba(0, 0, 0, 0.75);
  }
  .ant-tooltip-inner {
    box-shadow: 0px 9px 28px 8px rgba(0, 0, 0, 0.05),
      0px 6px 16px 0px rgba(0, 0, 0, 0.08);
    border-radius: 1px;
  }
`;
