import styled from "styled-components";
import { FontMixinGen, AllCenterMixin } from "../../util/cssMixin";

const BaseFlex = styled.div`
  ${FontMixinGen(14)}
  display:flex;
  align-items: center;
  height: 54px;
  ${(p) =>
    p.lstCfg
      .map(
        ([_, flex], idx) =>
          `div:nth-child(${idx + 1}){flex: ${flex} ${flex} 0;${AllCenterMixin}}`
      )
      .join("\n")}
  border-bottom: 1px solid rgba(0, 0, 0, 0.06);
`;

export const Item = styled(BaseFlex)`
  &:hover {
    background: rgba(250, 250, 250, 0.98);
  }
`;
export const Head = styled(BaseFlex)`
  font-weight: bold;
  background: rgba(0, 0, 0, 0.02);
`;
