//公共添加用户
import React, { Component } from "react";
import axios from 'axios';
import { Modal,Input,Spin} from 'antd';
import SchoolSelect from "../../coursesPublic/form/SchoolSelect";
import './AddUserModel.css'
import NoneData from "../../coursesPublic/NoneData";
import UserList from './UserList'
//维护数组 选择标题
let titlename=['添加学生','添加老师','添加助教','添加合作者']
class AddUserModal extends Component {
  constructor(props) {
    super(props);
    this.state={
      usersList:[],
      user_count:0,
      page:1,
      school_name:'',
      keyword:'',
      showone:true,
      isSpin:false,
      loading:false,
      hasMore:true,
      ismodelshow:false,
      checklist:[],
    }
  }

  componentDidMount(){
  }
  //点击搜索时调用接口 获取参数
  getusers=(scollpage,data)=>{
    const{school_name,keyword}=this.state;
    const{container_id,container_type,title}=this.props;
    //判断 如果姓名为空或为空字符串时 都不调用搜索

    this.setState({loading:true})
    if(!keyword.trim("")){
      this.setState({user_count:0})
      this.props.showNotification("请输入姓名,再进行搜索")
      return;
    }

    this.setState({isSpin:true})
    let url = `/users/member_search.json`;
    const page=scollpage||this.state.page;
    if(page===1){
      this.setState({usersList:[]})
    }
    axios.get(url,{params:{
      page:page,
      container_id:container_id,
      container_type:container_type,
      school_name:data?data:school_name, 
      keyword:keyword.trim("").replace(/\s/g,""),
      role:title===1?4:''

    }}).then((result)=>{
      if(result){
        if (!result.data.users || result.data.users.length == 0) { 
          this.setState({
            user_count:result.data.user_count,
            usersList: page === 1 ? result.data.users : this.state.usersList,
            page,
            loading: false,
            hasMore: false,
            isSpin:false,
            showone:false,
          });
        } else { 
          this.setState({
            user_count:result.data.user_count,
            usersList:page === 1? result.data.users: this.state.usersList.concat(result.data.users),
            isSpin:false,
            page,
            loading: false,
            showone:false,
            hasMore: result.data.users.length == 10,
          });
        }
      }
    })
  }
  setshowmodel=(type)=>{
    //弹窗时修改body值为不能滑动
    type?window.$(document.body).addClass("bodyov"):window.$(document.body).removeClass("bodyov");
    
    this.setState({ismodelshow:type,showone:true,keyword:'',school_name:'',checklist:[]});
  }

  onOrgNameChange = (value) => { 
    this.setState({ school_name: value });
  };

  select=(data)=>{
    this.getusers(1,data)
  }


  submit=()=>{
    const {showone}=this.state;
    if(showone){
      this.props.showNotification("请先进行搜索")
    }else{
      const{checklist}=this.state;
      const{title}=this.props;
      if(checklist&&checklist.length<=0){
        this.props.showNotification("请先在下面列表中选择要添加成员")
        return;
      }
      this.props.Ok(checklist,title)
    }
  
    
  }
  getcheckout=(data)=>{
    this.setState({checklist:data})
  }

  render(){
    const {title,width,isone}=this.props;
    const {keyword,user_count,showone,isSpin,usersList,school_name,loading,page,hasMore}=this.state;
    return(
      <Modal
        title={titlename[title-1]}
        width={width||'600px'}
        visible={this.state.ismodelshow}
        footer={null}
        destroyOnClose={true}
        onCancel={()=>this.setshowmodel(false)}
        centered={true}
        className={"addTeacherModal courseForm"}
      >
        <div>
          <div className="df">
              <span className="firstLabel label" style={{ flex: "0 0 40px" }}>
                姓名:
              </span>
              <Input allowClear placeholder="请输入真实姓名"  value={keyword}  height={"40px"} onChange={(e) => { this.setState({ keyword: e.target.value }); }}
                style={{ width: "410px", marginRight: "31px" }}
                onPressEnter={()=>this.getusers(1)}
              ></Input>
              <span  className="label" style={{ minWidth: "36px", flex: "0 0 40px" }} > 单位: </span>
              <SchoolSelect value={school_name} isTeacher={true} onChange={this.onOrgNameChange} onSelect={this.select}></SchoolSelect>
              <a className="task-btn task-btn-orange selectbtn" onClick={()=>this.getusers(1)}> 搜索 </a>
          </div>
            {isone&&showone?<NoneData isselect={true}/>:user_count>0? <Spin spinning={isSpin}> <UserList usersList={usersList} getcheckout={this.getcheckout} loading={loading} hasMore={hasMore} page={page} user_count={user_count} getusers={this.getusers}/></Spin> :<NoneData/>}
            <div className="mt20 marginauto clearfix edu-txt-center">
                <a onClick={()=>this.setshowmodel(false)} className="pop_close task-btn mr30">{'取消' }</a>
                <a onClick={this.submit} className="task-btn task-btn-orange" id="submit_send_shixun">{"确定" }</a>
            </div>
       </div>
      </Modal>
    )
  }
}
export default AddUserModal;
