//用户信息显示列表
import React, { Component } from "react";
import './AddUserModel.css'
import {Checkbox,Tooltip} from 'antd'
import {getDateTime} from 'educoder'
import InfiniteScroll from "react-infinite-scroller";

class UserList extends Component {
    constructor(props){
        super(props);
        this.state={
            checkBoxValues: [],
            page:1,
        }
    }


    handleInfiniteOnLoad=()=>{
        if(this.props.page===1){
           this.setState({page:1})
        }
        this.props.getusers(this.state.page+1);
        this.setState({page:this.state.page+1})
    }

    onCheckBoxChange=(checkBoxValues)=>{
        
        this.setState({checkBoxValues})
        this.props.getcheckout(checkBoxValues)
    }
    ischeckout=(id)=>{
      //判断 如果数组包含当前id 就移除当前id
      let cs=[];
      if(this.state.checkBoxValues.filter(item=>item===id).length>0){
        cs= this.state.checkBoxValues.filter(item=>item!==id);
     }else{
         cs= this.state.checkBoxValues.concat(id);
     }
     this.onCheckBoxChange(cs)
    }

    render(){
        const{usersList,loading,hasMore} =this.props;
        const{checkBoxValues}=this.state
        return(
            <div style={{height:"240px"}}>
            <div className="clearfix mb2" style={{ margin: "0px 20px 6px"}}>
                <Checkbox className="fl" style={{ visibility: "hidden" }}></Checkbox>
                <span className="fl task-hide with10" style={{ maxWidth: "208px" }}> {"姓名"}</span>
                <span className="fl task-hide with12" style={{ maxWidth: "208px" ,position:"relative"}}>{"手机号"}</span>
                <span className="fl task-hide with12" style={{ maxWidth: "208px" ,position:"relative"}}>{"邮箱"}</span>
                <span className="fl task-hide with12" style={{ maxWidth: "208px" ,position:"relative"}}>{"学号/工号"}</span>
                <span className="fl task-hide with12" style={{ maxWidth: "208px" ,position:"relative"}}>{"学校/单位"} </span>
                <span className="fl task-hide with12" style={{ maxWidth: "208px" ,position:"relative"}}>{"院系部门"} </span>
                <span className="fl task-hide width8" style={{ maxWidth: "208px" ,position:"relative"}}>{"实名认证"}</span>
                <span className="fl task-hide with12" style={{ maxWidth: "208px" ,position:"relative"}}>{"最后登录时间"} </span>
                <span className="fl task-hide with10" style= {{ maxWidth: "48px",marginLeft:'15px'   ,position:"relative"}}>{"状态"} </span>
            </div>
            <div className="edu-back-skyblue padding10-15" style={{ height: "222px", overflowY: "scroll", overflowAnchor: "none",}} >
                <InfiniteScroll
                    threshold={10}
                    initialLoad={false}
                    pageStart={0}
                    loadMore={this.handleInfiniteOnLoad}
                    hasMore={!loading&&hasMore}
                    useWindow={false}
                >
                 <Checkbox.Group
                  style={{ width: "100%" }}
                  onChange={this.onCheckBoxChange}
                  value={checkBoxValues}
                >
                    {usersList&&usersList.map((list)=>{
                        return(
                          <div className="clearfix mb7" style={{cursor:'pointer'}} key={list.numid} onClick={()=>this.ischeckout(list.numid)} >
                            <Checkbox className="fl" value={list.numid} key={list.numid} disabled={list.added===0?false:true}></Checkbox>
                            <span className="fl task-hide with10 ml5" style={{ maxWidth: "208px" }}><Tooltip placement="bottomLeft" title={list.username?list.username:''}><a  href={`/users/${list.login}`}  target="_blank">{list.username?list.username.length>4?list.username.slice(0,4)+"...":list.username:'--'}</a></Tooltip></span>
                            <span className="fl task-hide with12 pr25" style={{ maxWidth: "208px" ,position:"relative"}}>{list.phone?list.phone:'--'}</span>
                            <span className="fl task-hide with12 pr25" style={{ maxWidth: "208px" ,position:"relative"}}><Tooltip placement="bottomLeft" title={list.email?list.email:''}>{list.email?list.email:'--'}</Tooltip></span>
                            <span className="fl task-hide with12 pr25" style={{ maxWidth: "208px" ,position:"relative"}}><Tooltip placement="bottomLeft" title={list.student_number?list.student_number:''}>{list.student_number?list.student_number:"--"}</Tooltip></span>
                            <span className="fl task-hide with12 pr25" style={{ maxWidth: "208px" ,position:"relative"}}><Tooltip placement="bottomLeft" title={list.school_name?list.school_name:''}>{list.school_name?list.school_name.length>5?list.school_name.slice(0,5)+"...":list.school_name:'--'}</Tooltip> </span>
                            <span className="fl task-hide with12 pr25" style={{ maxWidth: "208px" ,position:"relative"}}><Tooltip placement="bottomLeft" title={list.depart_name?list.depart_name:''}>{list.depart_name?list.depart_name.length>5?list.depart_name.slice(0,5)+"...":list.depart_name:'--'}</Tooltip> </span>
                            <span className="fl task-hide width8 pr25" style={{ maxWidth: "208px" ,position:"relative"}}>{list.auth?'是':'否'}</span>
                            <span className="fl task-hide with12 " style={{ maxWidth: "208px" ,position:"relative"}}>{list.last_login_on?getDateTime(list.last_login_on,'yyyy-MM-dd hh:mm'):'--'} </span>
                            <span className="fl task-hide with10 statustitle" style= {{ maxWidth: "48px",marginLeft:'15px',position:"relative"}}>{list.added===0?'':'已添加'}</span>
                        </div>
                        )
                    })
                    }
                </Checkbox.Group>

              </InfiniteScroll>
            </div>
        </div>  
        )
    }
}
export default UserList;

