import React, { Component } from "react";
import { WordsBtn } from 'educoder';
import { Spin } from "antd";
import axios from 'axios';
import ShixunCustomsPass from "./Shixunworkdetails/ShixunCustomsPass";
import '../css/members.css';
import "../common/formCommon.css";
import '../css/Courses.css';
import './style.css';




class ShixunWorkDetails extends Component {

	constructor(props) {
		super(props);
		this.state = {
			data: undefined,
			spinning: true
		}
	}

	componentDidMount() {
		this.setState({
			spinning: true
		})
		let homeworkid = this.props.match.params.homeworkid;
		let userid = this.props.match.params.userid;
		let url = "/homework_commons/" + homeworkid + "/code_review_detail.json";
		axios.get(url, {
			params: {
				user_id: userid,
			}
		}).then((result) => {
			if (result.status === 200) {
				if (result.data.status === 403 || result.data.status === 401 || result.data.status === 407 || result.data.status === 408 || result.data.status === 409 || result.data.status === 500) {

				} else {
					this.setState({
						data: result.data,
						spinning: false
					})
				}

			}
		}).catch((error) => {
			console.log(error)
		})

		let query = this.props.location.pathname;
		const type = query.split('/');
		this.setState({
			shixuntypes: type[3]
		})
	}
	updatas = () => {
		this.setState({
			spinning: true
		})
		let homeworkid = this.props.match.params.homeworkid;
		let userid = this.props.match.params.userid;
		let url = "/homework_commons/" + homeworkid + "/code_review_detail.json";
		axios.get(url, {
			params: {
				user_id: userid,
			}
		}).then((result) => {
			if (result.status === 200) {
				if (result.data.status === 403 || result.data.status === 401 || result.data.status === 407 || result.data.status === 408 || result.data.status === 409 || result.data.status === 500) {

				} else {
					this.setState({
						data: result.data,
						spinning: false
					})
				}

			}
		}).catch((error) => {
			console.log(error)
		})
	}
	goback = (sum) => {
		this.props.history.replace(`/classrooms/${this.props.match.params.coursesId}/shixun_homeworks/${this.props.match.params.homeworkid}/list?tab=2`);
	}
	render() {
		let { data } = this.state;
		document.title = data && data.course_name;
		return (
			<Spin size="large" spinning={this.state.spinning} style={{ marginTop: "13%" }}>
				<div className="newMain clearfix ">
					{data === undefined ? "" :
						<div className={"educontent mb20"}>

							<div className="educontent">
								<p className="clearfix mt20">
									<a className="fl color-grey-9 btn colorgrey  hovercolorblue"
										href={`/classrooms/${data && data.course_id}/shixun_homeworks/${data && data.homework_common_id}`}
									>
										<a className={"color-grey-9"} >{data && data.course_name}</a>
									</a>
									<span className="color-grey-9 fl ml3 mr3">&gt;</span>
									<a className="btn colorgrey fl hovercolorblue grey"
										href={`/classrooms/${data && data.course_id}/shixun_homeworks/${data && data.homework_common_id}/list?tab=0`}>
										<span className={"color-grey-9"}>实训作业</span>
									</a>
									<span className="color-grey-9 fl ml3 mr3">&gt;</span>
									<WordsBtn className="fl">{data && data.username}</WordsBtn>
								</p>
							</div>

							<div className="padding10-30 clearfix" style={{
								padding: '10px 2px'
							}}>
								<span className="fl font-18">{data && data.homework_common_name}</span>
								<a className="fr color-grey-9 mt4" onClick={this.goback}>返回</a>
							</div>

							<div className="padding10-30  edu-back-white clearfix" style={{
								padding: '10px 13px'
							}}>
								<span className="fl color-orange font-14">非编程类型任务，不参与查重</span>
								<span className="fr mt4">
									<span className={"color656565"}>被查作品：</span>
									<span className={"mr50"}><span className={"color-orange"}>{data && data.username}</span></span>
									{data && data.eff_score === null || data && data.eff_score === undefined || data && data.eff_score_full === null || data && data.eff_score_full === undefined ? "" : <span className={"mr50"}>效率分：<span className={"color-orange"}>{data && data.eff_score}</span>/{data && data.eff_score_full}</span>}
									<span className={""}>最终成绩：<span className={"color-orange"}>{data && data.final_score}</span>分</span>
								</span>
							</div>

							<div className="stud-class-set bor-bottom-greyE">
								<div className="clearfix edu-back-white poll_list">
									<ShixunCustomsPass
										{...this.props}
										{...this.state}
										updatas={() => this.updatas()}
										data={data}
									/>
								</div>
							</div>
						</div>
					}
				</div>
			</Spin>
		)
	}
}

export default ShixunWorkDetails;