import React, { Component } from "react";
import { Row, Col, Popover, Icon } from "antd";
import echarts from "../../../components/equire-echarts";

class Dynamiclist extends Component {
  constructor(props) {
    super(props);
    this.state = {};
  }

  componentDidMount() {
    console.log(this.props.course_members);
    const { course_members } = this.props;
    const chartsOption = {
      tooltip: {
        trigger: "axis",
        formatter: (param) => {
          console.log(param);
          let name = param[0].name;
          if (name.length > 8) {
            name = name.substr(0, 5) + "...";
          }
          const title = `<div>${name}</div>`;
          const value = param.map((item) => {
            return `<div>${item.marker}活跃度: ${item.value}</div>`;
          });
          return title + value.join("");
        },
      },
      xAxis: {
        type: "category",
        data: course_members.map((item) => {
          const { user_name } = item;
          if (user_name.length > 5) {
            return user_name.substr(0, 5) + "...";
          } else {
            return user_name;
          }
        }),
        axisLabel: { interval: 0 },
      },
      yAxis: {
        type: "value",
        splitLine: {
          lineStyle: {
            type: "dashed",
          },
        },
      },
      series: [
        {
          data: course_members.map((item) => item.total_score),
          type: "bar",
          itemStyle: {
            color: "#40a9ff",
          },
        },
      ],
    };
    const signInCharts = echarts.init(document.getElementById("barCharts"));
    signInCharts.setOption(chartsOption);
  }
  render() {
    const content = (
      <div className={"Statisticscircle"}>
        <p>作业完成数（*10）</p>
        <p>试卷完成数（*10）</p>
        <p>问卷完成数（*7）</p>
        <p>资源发布数（*5）</p>
        <p>帖子发布数（*2）</p>
        <p>帖子回复数（*1）</p>
        <p>作业回复数（*1）</p>
      </div>
    );
    return (
      <React.Fragment>
        <Row>
          <Col span={12} className={"top10s"}>
            Top 10
          </Col>
          <Col span={12} className={"Statisticsliboxjsgz"}>
            <span className={"mr10"}>计算规则</span>
            <Popover
              placement="bottom"
              title={"活动规则计算说明"}
              content={content}
              trigger="hover"
            >
              <Icon type="info-circle" />
            </Popover>
          </Col>
        </Row>
        <div id="barCharts" style={{ height: 400, width: "100%" }}></div>
      </React.Fragment>
    );
  }
}
export default Dynamiclist;
