import React, { useState } from 'react'
import TpmMdEditor from '../../tpm/challengesnew/tpm-md-editor'
import './index.scss'

export default ({ active, mid, onActive, onCommit }) => {
  const [value, setValue] = useState('')
  const [error, setError] = useState(false)

  function onChange(v) {
    setValue(v)
    setError(false)
  }

  function onCommitHandler() {
    if (!value) {
      setError(true)
      return
    }
    setValue('')
    onCommit(value, mid)
  }
  return (
    <div className="memo-detail-md-editor">
      <div className={`flex-container ${active ? 'hide' : ''}`} onClick={onActive}>
        <input type="text" placeholder='说点什么' />
        <a className="btn-send">发表</a>
      </div>
      <div className={`md-container ${active ? '' : 'hide'}`}>
        <TpmMdEditor mdID='memo-md' error={error} showResizeBar={true} initValue={value} onChange={onChange} height={200} noStorage={true} startInit={active} />
        <div className="flex-container">
          {error ? <p className='error-tip'>不能为空</p> : <p></p>}
          <a className="btn-send" onClick={onCommitHandler}>发表</a>
        </div>
      </div>
    </div>
  )
}