import React from "react";
import { Form, Divider } from "antd";
import Selector from "./components/Selector";
import FooterLink from "./components/FooterLink";

const mock = [
  {
    item_type: "MULTIPLE",
    items_by_item_type: [
      {
        sub_discipline_id: 12,
        sub_discipline_name: "Java程序设计",
        discipline_id: 7,
        discipline_name: "程序设计语言",
        items_by_item_type_and_sub_discipline: [
          {
            difficulty: 1,
            items_count: 3,
          },
        ],
      },
    ],
  },
  {
    item_type: "SINGLE",
    items_by_item_type: [
      {
        sub_discipline_id: 12,
        sub_discipline_name: "Java程序设计",
        discipline_id: 7,
        discipline_name: "程序设计语言",
        items_by_item_type_and_sub_discipline: [
          {
            difficulty: 1,
            items_count: 10,
          },
        ],
      },
    ],
  },
  {
    item_type: "JUDGMENT",
    items_by_item_type: [
      {
        sub_discipline_id: 12,
        sub_discipline_name: "Java程序设计",
        discipline_id: 7,
        discipline_name: "程序设计语言",
        items_by_item_type_and_sub_discipline: [
          {
            difficulty: 1,
            items_count: 2,
          },
        ],
      },
    ],
  },
  {
    item_type: "PROGRAM",
    items_by_item_type: [
      {
        sub_discipline_id: 13,
        sub_discipline_name: "信号与系统",
        discipline_id: 8,
        discipline_name: "电子技术",
        items_by_item_type_and_sub_discipline: [
          {
            difficulty: 1,
            items_count: 1,
          },
        ],
      },
      {
        sub_discipline_id: 12,
        sub_discipline_name: "Java程序设计",
        discipline_id: 7,
        discipline_name: "程序设计语言",
        items_by_item_type_and_sub_discipline: [
          {
            difficulty: 1,
            items_count: 4,
          },
        ],
      },
      {
        sub_discipline_id: 26,
        sub_discipline_name: "Python程序设计",
        discipline_id: 7,
        discipline_name: "程序设计语言",
        items_by_item_type_and_sub_discipline: [
          {
            difficulty: 1,
            items_count: 1,
          },
        ],
      },
      {
        sub_discipline_id: 23,
        sub_discipline_name: "Java程序设计",
        discipline_id: 7,
        discipline_name: "程序设计语言",
        items_by_item_type_and_sub_discipline: [
          {
            difficulty: 1,
            items_count: 1,
          },
        ],
      },
    ],
  },
];

class QuestionCount extends React.Component {
  constructor(props) {
    super(props);
    this.state = {};
  }
  render() {
    const { form } = this.props;
    const { optinalData } = this.props;
    return (
      <Form layout="inline">
        {optinalData.map((item, index) => (
          <div key={item.item_type}>
            <Selector form={form} data={item} />
            {index === optinalData.length - 1 ? null : <Divider />}
          </div>
        ))}
        <FooterLink />
      </Form>
    );
  }
}
export default QuestionCount;
