import React, { Component } from "react";
import { DragDropContext, Draggable, Droppable } from "react-beautiful-dnd";
import axios from "axios";
import "../testioncss/testioncss.css";
import "../../tpm/newshixuns/css/Newshixuns.css";
import Paperlibraryseeid_items from "./Paperlibraryseeid_items";
class Paperreview_item extends Component {
  constructor(props) {
    super(props);

    this.state = {
      questions: 0,
      totalscore: 0,
      total: 0,
      modalsTypedel: false,
      modalsTypey: false,
      modalsTypeys: false,
      modalsTypedels: false,
      titilesm: "",
      titilesms: "",
      singlebool: false,
      multiplebool: false,
      judgmentbool: false,
      programbool: false,
      paperreviewsingleindex: "无",
      set_scoreid: null,
      item_bank_id: null,
    };
  }

  onDragEnd = (result, qt) => {
    if(!result.destination){
			return
		}
    const ids = this.props[qt].questions[result.source.index].id;
    const positions = this.props[qt].questions[result.destination.index]
      .position;
    const url = `/examination_items/${ids}/adjust_position.json`;
    var data = {
      position: positions,
    };
    axios
      .post(url, data)
      .then((result) => {
        if (result.data.status == 0) {
          // this.props.showNotification(`拖动成功`);
          this.props.getdata({});
        }
      })
      .catch((error) => {
        //console.log(error);
      });
  };

  render() {
    let {
      single_questions,
      multiple_questions,
      judgement_questions,
      program_questions,
      completion_questions,
      subjective_questions,
    } = this.props;
    const mapIndex = (name) => {
      const datamap = {
        single_questions,
        multiple_questions,
        judgement_questions,
        program_questions,
        completion_questions,
        subjective_questions,
      };
      const arr = Object.keys(datamap).filter((key) =>  datamap[key]);
      let rindex;
      arr.map((item, index) => {
        if (name === item) {
          rindex = index;
        }
	  });
	  const resultArr = ['一','二','三','四','五','六']
	  return resultArr[rindex];
	};
    return (
      <div className=" w100s">
        <div className="w100s ">
          {/*单选题*/}
          {single_questions && single_questions ? (
            <div
              className="backgroudwhites"
              style={{
                position: "relative",
              }}
            >
              <div className="w100s mt20 mb20 postitonrelati">
                <div
                  className={
                    "w100s sortinxdirection  intermediatecenterysls mb20"
                  }
                >
                  <p className={"yldxtit"}>一、单选题</p>{" "}
                  <p className="ml15 yldxtits">
                    （共{single_questions && single_questions.questions_count}
                    题；共{single_questions && single_questions.questions_score}
                    分）
                  </p>
                </div>

                <DragDropContext
                  onDragEnd={(result) =>
                    this.onDragEnd(result, "single_questions")
                  }
                >
                  <Droppable droppableId={"0"}>
                    {(provided, snapshot) => (
                      <div
                        ref={provided.innerRef}
                        {...provided.droppableProps}
                        className={""}
                        onScroll={this.contentViewScrolledit}
                      >
                        {single_questions &&
                          single_questions.questions.map((object, index) => {
                            return (
                              <Draggable
                                key={object.id}
                                draggableId={object.id}
                                index={index}
                                className={""}
                              >
                                {(provided, snapshot) => (
                                  <div
                                    key={index}
                                    ref={provided.innerRef}
                                    {...provided.draggableProps}
                                    {...provided.dragHandleProps}
                                  >
                                    <Paperlibraryseeid_items
                                      typenames={"SINGLE"}
                                      typenamesn={"单选题"}
                                      key={index}
                                      indexs={index}
                                      indexx={index + 1}
                                      indexxy={index}
                                      objectsingle={object}
                                    ></Paperlibraryseeid_items>
                                  </div>
                                )}
                              </Draggable>
                            );
                          })}
                      </div>
                    )}
                  </Droppable>
                </DragDropContext>
              </div>
            </div>
          ) : (
            ""
          )}

          {multiple_questions && multiple_questions ? (
            <div
              className="backgroudwhites"
              style={{
                position: "relative",
              }}
            >
              <div className="w100s  mb20 postitonrelati">
                <div
                  className={
                    "w100s sortinxdirection  intermediatecenterysls mb20"
                  }
                >
                  <p className={"yldxtit"}>
                    {single_questions === null ? "一" : "二"}、多选题
                  </p>
                  <p className="ml15 yldxtits">
                    （共
                    {multiple_questions && multiple_questions.questions_count}
                    题；共
                    {multiple_questions && multiple_questions.questions_score}
                    分）
                  </p>
                </div>

                <DragDropContext
                  onDragEnd={(result) =>
                    this.onDragEnd(result, "multiple_questions")
                  }
                >
                  <Droppable droppableId={"0"}>
                    {(provided, snapshot) => (
                      <div
                        ref={provided.innerRef}
                        {...provided.droppableProps}
                        className={""}
                        onScroll={this.contentViewScrolledit}
                      >
                        {multiple_questions &&
                          multiple_questions.questions.map((object, index) => {
                            return (
                              <Draggable
                                key={object.id}
                                draggableId={object.id}
                                index={index}
                                className={""}
                              >
                                {(provided, snapshot) => (
                                  <div
                                    key={index}
                                    ref={provided.innerRef}
                                    {...provided.draggableProps}
                                    {...provided.dragHandleProps}
                                  >
                                    <Paperlibraryseeid_items
                                      typenames={"MULTIPLE"}
                                      typenamesn={"多选题"}
                                      key={index}
                                      indexs={index}
                                      indexx={index + 1}
                                      indexxy={index}
                                      objectsingle={object}
                                    ></Paperlibraryseeid_items>
                                  </div>
                                )}
                              </Draggable>
                            );
                          })}
                      </div>
                    )}
                  </Droppable>
                </DragDropContext>
              </div>
            </div>
          ) : (
            ""
          )}

          {judgement_questions && judgement_questions ? (
            <div
              className={"backgroudwhites"}
              style={{
                position: "relative",
              }}
            >
              <div className="w100s  mb20 postitonrelati">
                <div
                  className={
                    "w100s sortinxdirection   intermediatecenterysls mb20 "
                  }
                >
                  <p className={"yldxtit"}>
                    {mapIndex("judgement_questions")}
                    、判断题
                  </p>{" "}
                  <p className="ml15 yldxtits">
                    （共
                    {judgement_questions && judgement_questions.questions_count}
                    题；共
                    {judgement_questions && judgement_questions.questions_score}
                    分）
                  </p>
                </div>

                <DragDropContext
                  onDragEnd={(result) =>
                    this.onDragEnd(result, "judgement_questions")
                  }
                >
                  <Droppable droppableId={"0"}>
                    {(provided, snapshot) => (
                      <div
                        ref={provided.innerRef}
                        {...provided.droppableProps}
                        className={""}
                        onScroll={this.contentViewScrolledit}
                      >
                        {judgement_questions &&
                          judgement_questions.questions.map((object, index) => {
                            return (
                              <Draggable
                                key={object.id}
                                draggableId={object.id}
                                index={index}
                                className={""}
                              >
                                {(provided, snapshot) => (
                                  <div
                                    key={index}
                                    ref={provided.innerRef}
                                    {...provided.draggableProps}
                                    {...provided.dragHandleProps}
                                  >
                                    <Paperlibraryseeid_items
                                      typenames={"JUDGMENT"}
                                      typenamesn={"判断题"}
                                      key={index}
                                      indexs={index}
                                      indexx={index + 1}
                                      indexxy={index}
                                      objectsingle={object}
                                    ></Paperlibraryseeid_items>
                                  </div>
                                )}
                              </Draggable>
                            );
                          })}
                      </div>
                    )}
                  </Droppable>
                </DragDropContext>
              </div>
            </div>
          ) : (
            ""
          )}

          {program_questions && program_questions ? (
            <div
              className={"backgroudwhites"}
              style={{
                position: "relative",
              }}
            >
              <div className="w100s  mb20 postitonrelati">
                <div
                  className={
                    "w100s sortinxdirection intermediatecenterysls mb20"
                  }
                >
                  <p className={"yldxtit"}>
                    {mapIndex("program_questions")}
                    、编程题
                  </p>{" "}
                  <p className="ml15 yldxtits">
                    （共{program_questions && program_questions.questions_count}
                    题；共
                    {program_questions && program_questions.questions_score}分）
                  </p>
                </div>

                <DragDropContext
                  onDragEnd={(result) =>
                    this.onDragEnd(result, "program_questions")
                  }
                >
                  <Droppable droppableId={"0"}>
                    {(provided, snapshot) => (
                      <div
                        ref={provided.innerRef}
                        {...provided.droppableProps}
                        className={""}
                        onScroll={this.contentViewScrolledit}
                      >
                        {program_questions &&
                          program_questions.questions.map((object, index) => {
                            return (
                              <Draggable
                                key={object.id}
                                draggableId={object.id}
                                index={index}
                                className={""}
                              >
                                {(provided, snapshot) => (
                                  <div
                                    key={index}
                                    ref={provided.innerRef}
                                    {...provided.draggableProps}
                                    {...provided.dragHandleProps}
                                  >
                                    <Paperlibraryseeid_items
                                      key={index}
                                      indexs={index}
                                      indexx={index + 1}
                                      indexxy={index}
                                      typenames={"PROGRAM"}
                                      typenamesn={"编程题"}
                                      objectsingle={object}
                                    ></Paperlibraryseeid_items>
                                  </div>
                                )}
                              </Draggable>
                            );
                          })}
                      </div>
                    )}
                  </Droppable>
                </DragDropContext>
              </div>
            </div>
          ) : (
            ""
          )}
          {completion_questions && completion_questions ? (
            <div
              className={"backgroudwhites"}
              style={{
                position: "relative",
              }}
            >
              <div className="w100s  mb20 postitonrelati">
                <div
                  className={
                    "w100s sortinxdirection   intermediatecenterysls mb20 "
                  }
                >
                  <p className={"yldxtit"}>{mapIndex("completion_questions")}、填空题</p>{" "}
                  <p className="ml15 yldxtits">
                    （共
                    {completion_questions &&
                      completion_questions.questions_count}
                    题；共
                    {completion_questions &&
                      completion_questions.questions_score}
                    分）
                  </p>
                </div>

                <DragDropContext
                  onDragEnd={(result) =>
                    this.onDragEnd(result, "completion_questions")
                  }
                >
                  <Droppable droppableId={"0"}>
                    {(provided, snapshot) => (
                      <div
                        ref={provided.innerRef}
                        {...provided.droppableProps}
                        className={""}
                        onScroll={this.contentViewScrolledit}
                      >
                        {completion_questions &&
                          completion_questions.questions.map(
                            (object, index) => {
                              return (
                                <Draggable
                                  key={object.id}
                                  draggableId={object.id}
                                  index={index}
                                  className={""}
                                >
                                  {(provided, snapshot) => (
                                    <div
                                      key={index}
                                      ref={provided.innerRef}
                                      {...provided.draggableProps}
                                      {...provided.dragHandleProps}
                                    >
                                      <Paperlibraryseeid_items
                                        typenames={"COMPLETION"}
                                        typenamesn={"填空题"}
                                        key={index}
                                        indexs={index}
                                        indexx={index + 1}
                                        indexxy={index}
                                        objectsingle={object}
                                      ></Paperlibraryseeid_items>
                                    </div>
                                  )}
                                </Draggable>
                              );
                            }
                          )}
                      </div>
                    )}
                  </Droppable>
                </DragDropContext>
              </div>
            </div>
          ) : (
            ""
          )}
		  {subjective_questions && subjective_questions ? (
            <div
              className={"backgroudwhites"}
              style={{
                position: "relative",
              }}
            >
              <div className="w100s  mb20 postitonrelati">
                <div
                  className={
                    "w100s sortinxdirection   intermediatecenterysls mb20 "
                  }
                >
                  <p className={"yldxtit"}>{mapIndex("subjective_questions")}、简答题</p>{" "}
                  <p className="ml15 yldxtits">
                    （共
                    {subjective_questions &&
                      subjective_questions.questions_count}
                    题；共
                    {subjective_questions &&
                      subjective_questions.questions_score}
                    分）
                  </p>
                </div>

                <DragDropContext
                  onDragEnd={(result) =>
                    this.onDragEnd(result, "subjective_questions")
                  }
                >
                  <Droppable droppableId={"0"}>
                    {(provided, snapshot) => (
                      <div
                        ref={provided.innerRef}
                        {...provided.droppableProps}
                        className={""}
                        onScroll={this.contentViewScrolledit}
                      >
                        {subjective_questions &&
                          subjective_questions.questions.map(
                            (object, index) => {
                              return (
                                <Draggable
                                  key={object.id}
                                  draggableId={object.id}
                                  index={index}
                                  className={""}
                                >
                                  {(provided, snapshot) => (
                                    <div
                                      key={index}
                                      ref={provided.innerRef}
                                      {...provided.draggableProps}
                                      {...provided.dragHandleProps}
                                    >
                                      <Paperlibraryseeid_items
                                        typenames={"SUBJECTIVE"}
                                        typenamesn={"简答题"}
                                        key={index}
                                        indexs={index}
                                        indexx={index + 1}
                                        indexxy={index}
                                        objectsingle={object}
                                      ></Paperlibraryseeid_items>
                                    </div>
                                  )}
                                </Draggable>
                              );
                            }
                          )}
                      </div>
                    )}
                  </Droppable>
                </DragDropContext>
              </div>
            </div>
          ) : (
            ""
          )}
        </div>
      </div>
    );
  }
}

export default Paperreview_item;
