import React from 'react';
import NewHeader from './NewHeader'
import NewFooter from './NewFooter'
import SiderBar from './SiderBar'
import { downloadFile } from 'educoder'
import axios from 'axios';
import { Spin } from 'antd';
import './TPMIndex.css';
import LoginDialog from '../login/LoginDialog';
import AccountProfile from '../user/AccountProfile';
import AccountPhoneemail from '../user/AccountPhoneemail';
import {
	connect
} from 'react-redux';
import actions from '../../redux/actions';
import { getCourseParam } from '../../common/TextUtil';

function TPMIndexHOC(WrappedComponent) {
	return class II extends React.Component {
		constructor(props) {
			super(props)
			this.state = {
				resLoading: true,
				isRender: false,
				AccountProfiletype: false,
				AccountPhoneemailtype: false,

				globalLoading: false,
				isloginCancel: undefined,
				mygetHelmetapi: null,
			}
		}

		showShixun = () => {
			const { shixunId } = this.props.match.params
			const url = `/api/v1/shixuns/${shixunId}/show_shixun`

			axios.get(url, { withCredentials: true }).then((response) => {
				if (response.data && response.data.shixun) {
					this.initCommonState(response.data.current_user)
					this.setState(response.data);
				}

			}).catch((error) => {
				console.log(error)
			})
		}
		aboutFocus = () => {
			const { creator, watched } = this.state
			const focusUrl = `/api/v1/users/${creator.owner_id}/${watched ? 'unwatch' : 'watch'}?object_id=${creator.owner_id}&object_type=user`

			axios.get(focusUrl)
				.then((response) => {
					const status = response.data.status;
					if (status == 1) {
						this.setState({
							watched: !watched
						})
					}
				}).catch((error) => {
					console.log(error)
				})
		}

		keyupListener = (e) => {
			if (e.key === "Escape") {
				this.setState({ globalLoading: false })
			}
		}
		componentWillUnmount() {
			window.removeEventListener('keyup', this.keyupListener)
		}

		componentDidMount() {
			window.addEventListener('keyup', this.keyupListener)
			const { match, fetchUser, fetchEduCoderConfig, current_user } = this.props

			if (match.path === "/") {
			} else if (match.path === "/403") {
				document.title = "你没有权限访问";
			} else if (match.path === "/nopage") {
				document.title = "没有找到该页面";
			} else if (match.path === "/shixuns") {
				document.title = "实训项目";
			} else if (match.path === "/paths") {
				document.title = "实践课程";
			} else if (match.path === "/classrooms") {
				document.title = "教学课堂";
			}

			let params = getCourseParam()

			//目前平台的设计是 用户的权限随模块有变化
			if (!current_user) {
				fetchEduCoderConfig(params)
			} else {
				fetchUser(params)
			}
			this.getAppdata()
		}
		/**
			课堂权限相关方法，暂时写这里了 ----------------------------------------START
			ADMIN = 0       # 超级管理员
			CREATOR = 1     # 课程创建者
			PROFESSOR = 2     # 课程老师
			ASSISTANT_PROFESSOR = 3  # 课程助教
			STUDENT = 4     # 学生
			NORMAL = 5      # 普通用户

			v2
			# 课程权限判断
			ADMIN = 0       # 超级管理员
			BUSINESS = 1    # 运营人员
			CREATOR = 2     # 课程创建者   课堂管理员
			PROFESSOR = 3     # 课程老师
			ASSISTANT_PROFESSOR = 4  # 课程助教
			STUDENT = 5     # 学生
			NORMAL = 6      # 普通用户
			Anonymous = 7      # 普未登录
		*/
		//超管0
		isSuperAdmin = () => {
			const { coursedata } = this.props
			return coursedata.course_identity === 0
		}
		isCourseAdmin = () => {
			const { coursedata } = this.props
			return coursedata.course_identity === 2
		}
		//超管、运维0-1
		isClassManagement = () => {
			const { coursedata } = this.props
			return coursedata.course_identity < 2
		}
		//超管、运维、课堂管理0-2
		isAdminOrCreator = () => {
			const { coursedata } = this.props
			return coursedata.course_identity < 3
		}
		//超管、运维、课堂管理、老师0-3
		isAdminOrTeacher = () => {
			const { coursedata } = this.props
			return coursedata.course_identity < 4
		}
		// 助教===4
		isAssistant = () => {
			const { coursedata } = this.props
			return coursedata.course_identity === 4
		}
		// 超管、运维、课堂管理、老师、助教0-4
		isAdmin = () => {
			const { coursedata } = this.props
			return coursedata.course_identity < 5
		}
		// 学生5
		isStudent = () => {
			const { coursedata } = this.props
			return coursedata.course_identity === 5
		}
		// 超管、运维、课堂管理、老师、助教、学生0-5
		isAdminOrStudent = () => {
			const { coursedata } = this.props
			return coursedata.course_identity <= 5
		}
		// 游客未登录/非课堂成员6>
		isNotMember = () => {
			const { coursedata } = this.props
			return coursedata.course_identity >= 6
		}
		//课堂是否已结束
		isCourseEnd = () => {
			const { current_user } = this.props
			return current_user ? current_user.course_is_end : false
		}


		//获取数据为空的时候
		gettablogourlnull = () => {
			this.setState({
				mygetHelmetapi: undefined
			});
			document.title = "EduCoder";
			var link = document.createElement('link'),
				oldLink = document.getElementById('dynamic-favicon');
			link.id = 'dynamic-favicon';
			link.rel = 'shortcut icon';
			link.href = "/react/build/./favicon.ico";
			if (oldLink) {
				document.head.removeChild(oldLink);
			}
			document.head.appendChild(link);
		};

		//获取数据的时候
		gettablogourldata = (response) => {
			document.title = response.data.setting.name;
			var link = document.createElement('link'),
				oldLink = document.getElementById('dynamic-favicon');
			link.id = 'dynamic-favicon';
			link.rel = 'shortcut icon';
			link.href = '/' + response.data.setting.tab_logo_url;
			if (oldLink) {
				document.head.removeChild(oldLink);
			}
			document.head.appendChild(link);
		}
		//获取当前定制信息
		getAppdata = () => {
			try {
				var chromesettingArray = JSON.parse(localStorage.getItem('chromesetting'));
				var chromesettingresponseArray = JSON.parse(localStorage.getItem('chromesettingresponse'));
				this.setState({
					mygetHelmetapi: chromesettingArray
				});
				if (chromesettingArray.tab_logo_url) {
					this.gettablogourldata(chromesettingresponseArray);
				} else {
					this.gettablogourlnull();
				}
			} catch (e) {
				console.log("hoc获取游览器配置失败 重新请求开始读取配置");
				this.getAppdatausr();
			}

		};
		getAppdatausr = () => {
			let url = "/setting.json";
			axios.get(url).then((response) => {
				if (response) {
					if (response.data) {
						this.setState({
							mygetHelmetapi: response.data.setting
						});
						localStorage.setItem('chromesetting', JSON.stringify(response.data.setting));
						localStorage.setItem('chromesettingresponse', JSON.stringify(response));
						try {
							if (response.data.setting.tab_logo_url) {
								this.gettablogourldata(response);
							} else {
								this.gettablogourlnull();
							}
						} catch (e) {
							this.gettablogourlnull();
						}

					} else {
						this.gettablogourlnull();
					}

				} else {
					this.gettablogourlnull();
				}

			}).catch((error) => {
				this.gettablogourlnull();
			})
		}

		hideLoginDialog = () => {
			this.setState({
				isRender: false,
				isloginCancel: undefined
			})
		}
		showLoginDialog = () => {
			this.setState({
				isRender: true,
				isloginCancel: "iscancel"
			})
		}
		//验证登录是否成功方法
		checkIfLogin = () => {
			return this.props.current_user && this.props.current_user.login != ''
		}

		hideAccountProfile = () => {
			this.setState({
				AccountProfiletype: false
			})
		}
		showProfileCompleteDialog = () => {
			this.dialogObj = {}
			this.setState({
				AccountProfiletype: true
			})
		}
		showhideAccountPhoneemailDialog = () => {
			this.dialogObj = {}
			this.setState({
				AccountPhoneemailtype: true
			})
		}
		hideAccountPhoneemailtype = () => {
			this.setState({
				AccountPhoneemailtype: false
			})
		}
		//验证是否完善资料
		checkIfProfileCompleted = () => {
			return this.props.current_user && this.props.current_user.profile_completed
		}

		showaccountprofileDialog = () => {
			this.dialogObj = {
				content: '您需要去完成您的个人资料，才能使用此功能',
				okText: '立即完成',
				okHref: '/account/profile'
			}
			this.setState({
				AccountProfiletype: true,
			})
		}
		showProfessionalCertificationDialog = () => {
			this.dialogObj = {
				content: '您需要去完成您的职业认证，才能使用此功能',
				okText: '立即完成',
				okHref: '/account/certification'
			}
			this.setState({
				AccountProfiletype: true,
			})
		}
		checkIfProfessionalCertification = () => {
			return this.props.current_user && this.props.current_user.professional_certification
		}


		ShowOnlinePdf = (url) => {
			return axios({
				method: 'get',
				url: url,
				responseType: 'arraybuffer',
			}).then((result) => {
				var binaryData = [];
				binaryData.push(result.data);
				this.url = window.URL.createObjectURL(new Blob(binaryData, { type: "application/pdf" }));
				window.open(this.url);
			})
		}
		DownloadFileA = (title, url) => {
			let link = document.createElement('a');
			document.body.appendChild(link);
			link.href = url;
			link.download = title;
			//兼容火狐浏览器
			let evt = document.createEvent("MouseEvents");
			evt.initEvent("click", false, false);
			link.dispatchEvent(evt);
			document.body.removeChild(link);
		}

		DownloadOpenPdf = (type, url) => {
			type === true ? window.open(url) : window.location.href = url;
		}
		slowDownload = (url, tip) => {
			this._gLoadingTip = tip || '正在生成文件，请稍后...';
			this.setState({ globalLoading: true })
			const fileUrl = url;
			downloadFile({
				url: fileUrl,
				successCallback: (url) => {
					this.setState({ globalLoading: false })
					console.log('successCallback')
				},
				failCallback: (responseHtml, url) => {
					this.setState({ globalLoading: false })
					console.log('failCallback')
				}
			})
		}
		yslslowCheckresults = (tip) => {
			this._gLoadingTip = tip || '成绩计算中，请稍候...';
			this.setState({ globalLoading: true })
		}
		yslslowCheckresultsNo = () => {
			this.setState({ globalLoading: false })
		}

		showGlobalLoading = (tip) => {
			this._gLoadingTip = tip || '加载中，请稍后...';
			this.setState({ globalLoading: true })
		}
		hideGlobalLoading = () => {
			this.setState({ globalLoading: false })
		}

		MdifHasAnchorJustScorll = () => {
			//mdhash滚动
			let anchor = decodeURI(this.props.location.hash).replace('#', '');
			// 对应id的话, 滚动到相应位置
			if (!!anchor) {
				let anchorElement = document.getElementsByName(anchor);
				if (anchorElement) {
					if (anchorElement.length > 0) {
						anchorElement[anchorElement.length - 1].scrollIntoView();
					}
				}
			}
		}

		//跳转道描点的地方
		scrollToAnchor = (anchorName) => {
			if (anchorName) {
				// 找到锚点
				let anchorElement = document.getElementById(anchorName);
				// 如果对应id的锚点存在，就跳转到锚点
				if (anchorElement) {
					anchorElement.scrollIntoView();
				}
			}
		}

		render() {
			let { isRender, AccountProfiletype, AccountPhoneemailtype } = this.state;
			const common = {
				isSuperAdmin: this.isSuperAdmin,
				isAdminOrCreator: this.isAdminOrCreator,
				isClassManagement: this.isClassManagement,
				isCourseAdmin: this.isCourseAdmin,

				isAdmin: this.isAdmin,
				isAdminOrTeacher: this.isAdminOrTeacher,
				isAssistant: this.isAssistant,
				isStudent: this.isStudent,
				isAdminOrStudent: this.isAdminOrStudent,
				isNotMember: this.isNotMember,
				isCourseEnd: this.isCourseEnd,

				isUserid: this.props.coursedata && this.props.coursedata.userid,
				fetchUser: this.props.fetchUser,

				showLoginDialog: this.showLoginDialog,
				checkIfLogin: this.checkIfLogin,
				showProfileCompleteDialog: this.showProfileCompleteDialog,
				showhideAccountPhoneemailDialog: this.showhideAccountPhoneemailDialog,
				checkIfProfileCompleted: this.checkIfProfileCompleted,
				showaccountprofileDialog: this.showaccountprofileDialog,
				checkIfProfessionalCertification: this.checkIfProfessionalCertification,
				showProfessionalCertificationDialog: this.showProfessionalCertificationDialog,

				ShowOnlinePdf: (url) => this.ShowOnlinePdf(url),
				DownloadFileA: (title, url) => this.DownloadFileA(title, url),
				DownloadOpenPdf: (type, url) => this.DownloadOpenPdf(type, url),

				slowDownload: this.slowDownload,
				showGlobalLoading: this.showGlobalLoading,
				hideGlobalLoading: this.hideGlobalLoading,
				yslslowCheckresults: this.yslslowCheckresults,
				yslslowCheckresultsNo: this.yslslowCheckresultsNo,
				MdifHasAnchorJustScorll: this.MdifHasAnchorJustScorll,
				scrollToAnchor: this.scrollToAnchor

			};
			var mypath = this.props && this.props.match && this.props.match.path;
			return (
				<div className="indexHOC">
					{isRender === true ? <LoginDialog
						Modifyloginvalue={() => this.hideLoginDialog()}
						{...this.props}
						{...this.state}
					/> : ""}
					{/* AccountProfile 也用作职业认证 */}
					{AccountProfiletype === true ? <AccountProfile
						hideAccountProfile={() => this.hideAccountProfile()}
						{...this.props}
						{...this.state}
						{...this.dialogObj}
					/> : ""}
					{/*验证是否注册手机邮箱*/}
					{AccountPhoneemailtype === true ? <AccountPhoneemail
						hideAccountProfile={() => this.hideAccountPhoneemailtype()}
						{...this.props}
						{...this.state}
						{...this.dialogObj}
					/> : ""}
					{
						mypath && mypath === "/problemset" ?
							""
							:
							<SiderBar {...this.props} {...this.state} />
					}

					<style>{
						`
							.newContainers{
							  min-width: 1200px;
                max-width: unset;
                height: 100%;
                min-height: 100%;
								overflow: hidden;
							}
							.newHeaders{
							  // position: fixed;
								max-width: unset;
								background: #24292D !important;
								width: 100%;
								height: 60px !important;
								min-width: 1200px;
								z-index: 1000;
								-moz-box-shadow: 0px 0px 12px rgba(0,0,0,0.1);
								box-shadow: 0px 0px 12px rgba(0,0,0,0.1);
							}

              .globalSpin {
                max-height: 700px !important;
              }
              .indexHOC > .ant-spin-nested-loading {
                background: #000;
                height: 100%;
              }
              .indexHOC > .ant-spin-nested-loading > div > .ant-spin .ant-spin-dot {
                top: 50% !important;
              }

              .globalSpin .ant-spin-text {
                text-shadow: none !important;
                color: #fff;
              }
              .globalSpin .ant-spin-dot-item {
                background-color: #fff;
              }
							`
					}</style>


					<NewHeader {...this.state} {...this.props} {...common}></NewHeader>
					<Spin spinning={this.state.globalLoading} delay={0} className="globalSpin"
						size="large"
						tip={this._gLoadingTip || "加载中..."}
					>
						<div className="newContainer newContainers">
							<WrappedComponent
								{...this.props} {...this.state}
								showShixun={this.showShixun} aboutFocus={this.aboutFocus}
								{...common}
							>
							</WrappedComponent>

						</div>

					</Spin>

					<NewFooter {...this.state} {...this.props} />

				</div>
			);
		}
	}
}

const mapStateToProps = ({ educoderConfigReducer }) => {
	return {
		...educoderConfigReducer
	}
}

const mapDispatchToProps = (dispatch) => ({
	fetchUser: (params) => dispatch(actions.fetchUserInfo(params)),
	fetchEduCoderConfig: (params) => dispatch(actions.fetchEduCoderConfig(params)),
})

const IndexHoc = function (WrappedComponent) {
	return connect(mapStateToProps, mapDispatchToProps)(TPMIndexHOC(WrappedComponent))
}
export default IndexHoc

