import React, { Component } from 'react';
import { Link } from "react-router-dom";
import { Tooltip } from 'antd';

import axios from 'axios';

import { CircularProgress } from 'material-ui/Progress';
import RenderHtml from '../../../../components/render-html';

class Propaedeutics extends Component {
  constructor(props) {
    super(props)
    this.state = {
      PropaedeuticsListcontent: undefined,
      shixunId: undefined
    }
  }

  componentDidMount() {
    let id = this.props.match.params.shixunId;
    this.setState({
      shixunId: id
    })
    let url = "/shixuns/" + id + "/propaedeutics.json";
    axios.get(url).then((response) => {

      if (response.data.status === 403 || response.data.status === 401 || response.data.status === 500) {

      } else {
        if (response.data.content != null) {
          this.setState({
            PropaedeuticsListcontent: response.data.content
          })
        } else {
          this.setState({
            PropaedeuticsListcontent: ""
          })
        }
      }
    }).catch((error) => {
      console.log(error)
    });

  }

  render() {
    let { loadingContent } = this.props;
    let { PropaedeuticsListcontent, shixunId } = this.state

    return (
      <React.Fragment>
        <p className="clearfix mb10 pl20 pr20" style={{ display: this.props.identity < 5 && this.props.status < 3 ? "block" : 'none' }} >
          <Tooltip placement="bottom" title={"编辑"}>
            <Link to={"/shixuns/" + shixunId + "/update_propaedeutics"} className="fr audit_situationactive mt20" id="edit_propaedeutics">
              编辑
					</Link>
          </Tooltip>
        </p>

        <style>
          {
            `
            .editormd-html-preview, .editormd-preview-container {
                width:100% !important;
            }
            `
          }
        </style>
        {
          loadingContent ?
            <CircularProgress size={40} thickness={3}
              style={{ marginLeft: 'auto', marginRight: 'auto', marginTop: '200px', display: 'block' }} /> :
            <div id="collaborators_list_info" style={{ display: 'none', minHeight: '640px', padding: '20px 30px 30px 30px' }}>
              {PropaedeuticsListcontent === undefined ? "" : <RenderHtml value={PropaedeuticsListcontent} />}
            </div>
        }
      </React.Fragment>
    );
  }
}

export default Propaedeutics;
