import types from './actionTypes'
import axios from 'axios'
import { getEduCoderConfig, getUserInfo } from '../../services/educoder-config'

export function fetchEduCoderConfig(params) {
  return (dispatch => {
    const promise = getEduCoderConfig(params)
    promise.then(axios.spread((userRes, navigateRes) => {
      const user = userRes.data
      const navigate = navigateRes.data
      dispatch({
        type: types.GET_EDUCODER_CONFIG,
        payload: {
          tpmLoading: false,
          Headertop: navigate.top,
          Footerdown: navigate.down,
          current_user: user,
          user,
          coursedata: {
            course_identity: user.course_identity >= 0 ? user.course_identity : undefined,
            course_public: user.course_public,
            name: user.course_name,
            userid: user.user_id
          }
        }
      })
    }))
  })
}

export function fetchUserInfo(params) {
  return async (dispatch) => {
    const response = await getUserInfo(params)
    const user = response.data
    dispatch({
      type: types.GET_EDUCODER_CONFIG,
      payload: {
        tpmLoading: false,
        current_user: user,
        user,
        coursedata: {
          course_identity: user.course_identity >= 0 ? user.course_identity : undefined,
          course_public: user.course_public,
          name: user.course_name,
          userid: user.user_id
        }
      }
    })
  }
}